#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/*prototypes*/
double neigojo(double p, int R);
double jinnei(double p, double q, int R);
double otanei(double p, int R, int empiri);
/*double discrdis(double p, int indice, FILE *infile);
double jinneidis(double p, double q, FILE *infile);*/
double truncnegbinjcdist(double p);
double truncnegbinkimdist(double p, double q);
double truncnegbinprodist(double P);

extern double a, b, MOY;
extern int transiversions;

/*calculate the percent of transitions, transversions and total differences between each pair of sequences*/
int calcpercent(int Nseq, int Nsites, char **seq, double **ka, double t, int Opt, int R, int invar, int empiri, int distrib)
{
int i, j, k;
char c1, c2;
double p, q, P;
int sat=0, compt;


for(i=0;i<(Nseq-1);i++) {
		for(j=(i+1);j<Nseq;j++) {
				p=0.0;  /*transitional differences*/
				q=0.0;  /*transversional differences*/
				P=0.0;  /*differences for protein sequences*/
				compt=0;
				for(k=0;k<Nsites;k++) {	
						c1=seq[i][k];
						c2=seq[j][k];
						if(Opt==5) {
							if( (c1=='B' || c1=='J' || c1=='O' || c1=='U' || c1=='X' || c1=='Z' || c1=='*') || (c2=='B' || c2=='J' || c2=='O' || c2=='U' || c2=='X' || c2=='Z' || c2=='*') ) compt++;
							else if(c1!=c2) P=P+1;
							}
						else {
							if( (c1!='A' && c1!='C' && c1!='G' && c1!='T' && c1!='R' && c1!='Y') || (c2!='A' && c2!='C' && c2!='G' && c2!='T' && c2!='R' && c2!='Y') ) compt++;
							if( (c1=='R' && c2=='R') || (c1=='Y' && c2=='Y') ) if(transiversions==2) compt++;
							if( ((c1=='A' || c1=='G') && c2=='R') || ((c2=='A' || c2=='G') && c1=='R') ) if(transiversions==2) compt++;
							if( ((c1=='C' || c1=='T') && c2=='Y') || ((c2=='C' || c2=='T') && c1=='Y') ) if(transiversions==2) compt++;
							if( (c1=='A' || c1=='C' || c1=='G' || c1=='T') && (c2=='A' || c2=='C' || c2=='G' || c2=='T') ) if(c1!=c2) {
				if( (c1=='A' && c2=='G')||(c1=='G' && c2=='A')||(c1=='C' && c2=='T')||(c1=='T' && c2=='C') ) p=p+1;
				else q=q+1;
				}
							if( ((c1=='R' || c1=='A' || c1=='G') && c2=='Y') || ((c2=='R' || c2=='A' || c2=='G') && c1=='Y') ) q=q+1;
							if( ((c1=='Y' || c1=='C' || c1=='T') && c2=='R') || ((c2=='Y' || c2=='C' || c2=='T') && c1=='R') ) q=q+1;
							}
						}

				if(R==1 && invar==1) {
					p=(p/( (Nsites-compt)*(1-t) ));
					q=(q/( (Nsites-compt)*(1-t) ));
					P=(P/( (Nsites-compt)*(1-t) ));
					}
				else {
					p=(p/(Nsites-compt));
					q=(q/(Nsites-compt));
					P=(P/(Nsites-compt));
					}	
				
				if(Opt==1) {
					if( (p+q)>=0.75 ) {
							sat=1;
							break;
							}
					if(R==1 && distrib==2) ka[i][j]=truncnegbinjcdist(p+q);
					else ka[i][j]=neigojo(p+q, R);
					}
				if(Opt==2) {
					if( q>=0.5 || (2*p+q)>=1.0 ) {
									sat=1;
									break;
									}
					if(R==1 && distrib==2) ka[i][j]=truncnegbinkimdist(p, q);
					else ka[i][j]=jinnei(p, q, R);
					}
				if(Opt==5) {
					if(empiri==1) {
						if( (1-P-0.2*P*P)<=0.0 ) {
									sat=1;
									break;
									}
						ka[i][j]=otanei(P, R, empiri);
						}
					else {
						if(P>=1.0) {
							sat=1;
							break;
							}
						if(R==1 && distrib==2) ka[i][j]=truncnegbinprodist(P);
						else ka[i][j]=otanei(P, R, empiri);
						}
					}
				}		
		if(sat==1) break;
		}

return sat;				
}



/*function which calculates the distance of Nei and Gojobori
(modification of the Jukes-and-Cantor's distance for nucleic sequences using a
continuous gamma distribution)*/ 
double neigojo(double p, int R)
{
double d;
double x, y, z;

x=(4.0/3.0)*p;

if(R==2) {
	y=log(1-x);
	d=-(3.0/4.0)*y;
	}
else {
	y=pow( (1-x), (-1.0/a) );
	z=(3.0/4.0)*a;
	d=z*(y-1);
	}

return d;
}


/*function which calculates the distance of Jin and Nei
(modification of the Kimura's distance for nucleic sequences using a
continuous gamma distribution)*/ 
double jinnei(double p, double q, int R)
{
double d, d1, d2;
double x, y, z, z1, z2;

x=(1-(2*p)-q);
y=(1-(2*q));

if(R==2) {
	d1=-(1.0/2.0)*log(y);
	d2=-(1.0/2.0)*log(x)+(1.0/4.0)*log(y);
	z=log( x*sqrt(y) );
	if(p==0.0) d=d1;
	else d=-(1.0/2.0)*z;
	/*printf("d1=%f, d2=%f\n", d1, d2);*/
	if(transiversions==1) return d1;
	else return d;
	}
else {
	z1=pow(x, (-1.0/a));
	z2=pow(y, (-1.0/a));
	if(p==0.0) d=-(1.0/2.0)*(z1-1);
	else d=(a/2.0)*( z1+(z2/2)-(3.0/2) );
	return d;
	}

}


/*function which calculates the distance of Ota and Nei
(modification of the Poisson distance for protein sequences using a
continuous gamma distribution)*/ 
double otanei(double p, int R, int empiri)
{
double d;
double x, y;

x=1-p;

if(R==2) {
	if(empiri==1) d=-log( x-(0.2*p*p) );
	else d=-log(x);
	}
else {
	y=pow( x, (-1.0/a) );
	d=a*(y-1);
	}

return d;
}

/*function which calculates the Jukes-and-Cantor-like distance of Tourasse
and Gouy (modification of the Jukes-and-Cantor's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/
double truncnegbinjcdist(double p)
{
double d, V, Z, temp1, temp2, temp3, temp4;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-(4.0/3)*p;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-(3.0/4)*MOY*log(temp4);

return d;
}

/*function which calculates the Kimura-like distance of Tourasse
and Gouy (modification of the Kimura's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/
double truncnegbinkimdist(double p, double q)
{
double d1, d2, V, Z1, Z2, temp1, temp2, temp3, temp4, temp5, temp6, temp7;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-2*q;
Z1=temp1*temp2;
temp3=1-2*p-q;
Z2=temp1*temp3;

temp4=pow(Z1+1,(-1.0/a));
temp5=pow(Z2+1,(-1.0/a));
temp6=((1+b)/b)*(1-temp4);
temp7=((1+b)/b)*(1-temp5);

d1=-(1.0/4)*MOY*log(temp6);
d2=-(1.0/2)*MOY*log(temp7);
if(q==0.0) d1=0.0;
if(p==0.0) d2=d1;
/*printf("d1=%f, d2=%f\n", 2*d1, d2-d1);*/

if(transiversions==1) return 2*d1;
else return d1+d2;
}

/*function which calculates the Ota-and-Nei-like distance of Tourasse and Gouy
(modification of the Poisson distance for protein sequences using an
Invariant+Truncated Negative Binomial distribution)*/
double truncnegbinprodist(double P)
{
double d, V, Z, temp1, temp2, temp3, temp4;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-P;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-MOY*log(temp4);

return d;
}
