#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 1000
#define NESP 4000    /*maximum number of sequences read*/
#define nmlngth 10   /*number of characters in a species name*/

double a, b, t, MOY;
int kind;

/*prototypes*/
char *lirenom(FILE *infile);
double otaneicont(double p, int R, int empiri);
double neigojocont(double p, int R);
double neigojotransvercont(double q, int R);
double jinneicont(double p, double q, int R);
double *jinneitransiversions(double p, double q, int R);
double varotaneicont(double p, double N, int R);
double varneigojocont(double p, double N, int R);
double varjinneicont(double p, double q, double N, int R);
double truncnegbinjcdist(double p);
double truncnegbinjctransverdist(double q);
double truncnegbinkimdist(double p, double q);
double *truncnegbintransiversions(double p, double q);
double truncnegbinprodist(double P);

int transiversions, JCtransversions;
double *dtt;

int main(int argc, char *argv[])
{
char infilename[40], outfilename[40], clearfilename[40], excludefilename[40], exoutfilename[40], transifilename[40], transverfilename[40];
FILE *infile, *outfile, *clearfile, *excludefile, *exoutfile, *transifile, *transverfile;
char *seq[NESP];
char *seqname[NESP];
char line[MAX+1];
int Nseq, Nsites;
int i, j, jj, jjj, k, l, x, indice, compt;
int *pos;
int c;
char c1, c2;
double p, q, P, d, *v;
int Opt, R, printvar;
int L;
int u, sum, max;
double transi, trsver;
int invar, distrib, dist, empiri;
int clear, gaps, chname;
char *rseq[NESP];
int excl, exclu, exsite;


printf("*******************************************************\n");
printf("<<Program DISTGAMMA: computes evolutionary distances.>>\n\n");

/*if(argc>1)*/ strcpy(infilename, argv[1]);
/*open input file*/
/*printf("input name of sequences file (interleaved phylip format)?\n");*/
/*scanf("%s", infilename);*/
L=strlen(infilename);
infilename[L]='\0';
if( (infile=fopen(infilename, "r"))==NULL) {
				printf("can't open input file!\n");
				exit(1);
				}
chname=0;

/*calculate the distance between each pair of sequences and print the distance matrix*/
printf("\nChoose the distance you want to use: (input a number)\n");
/*printf("protein divergence?      1\nnucleic sequences:\nJukes and Cantor?        2\nKimura?                  3\nTransversional distance? 4\n");*/
printf("Jukes and Cantor?        2\nKimura?                  3\nTransversional distance? 4\n");
scanf("%d", &Opt);

if(Opt==4) JCtransversions=1;
else JCtransversions=2;
transiversions=2;

/*if(Opt==3) {
	printf("Do you want to distinguish transversional and transitional distances (Yes=1, No=2)?\n");
	scanf("%d", &transiversions);
	}

if(Opt==2) {
	printf("Do you want to compute a transversional distance (Yes=1, No=2)?\n");
	scanf("%d", &JCtransversions);
	}*/
	
printf("Do you want to correct the distances for rate variation among sites (Yes=1, No=2)?\n");
scanf("%d", &R);
if(Opt==1 && R==2) {
		printf("Do you want to use the empirical formula of Kimura (Yes=1, No=2)?\n");
		scanf("%d", &empiri);
		}
if(R==1) {
	printf("What kind of distribution do you want to use ? (enter a number)\n");
	printf("Invariant + truncated negative binomial?  <1>\n");
	printf("Continuous gamma?                         <2>\n");
	printf("Invariant + continuous gamma              <3>\n");
	scanf("%d", &kind);

	if(kind==1) {
		printf("What's the mean of the observed distribution?\n");
		scanf("%lf", &MOY);
		printf("MOY=%f\n", MOY);
		}

	printf("What's the value of a?\n");
	scanf("%lf", &a);
	printf("a=%f\n", a);

	if(kind==1) 
		{
		printf("What's the value of b?\n");
		scanf("%lf", &b);
		printf("b=%f\n", b);
		}

	/*printf("Do you want to take into account the invariant sites (Yes=1, No=2)?\n");
	scanf("%d", &invar);*/
	if(kind==1 || kind==3) invar=1;
	else invar=2;
	if(invar==1) {
		printf("What's the value of t?\n");
		scanf("%lf", &t);
		printf("t=%f\n", t);
		}
	
	}

printf("\nDo you want to delete undefined characters in all sequences <1> or specifically for each sequence pair <2>?\n");
scanf("%d", &clear);


/*read the header*/
fscanf(infile, "%d", &Nseq);  
fscanf(infile, "%d", &Nsites);
/*printf("%d, %d\n", Nseq, Nsites);*/
/*read the end of the header line*/
if( (fgets(line, MAX, infile))==NULL ) {
					printf("err_fgets\n");
					exit(1);
					}

/*allocate memory for all the pointers seq[i] */
for(i=0; i<Nseq; i++) {
			seq[i]=(char *)malloc((Nsites+1)*sizeof(char));
			if(seq[i]==NULL) {
					printf("not enough memory!\n");
					exit(1);
					}
			}


/*read all the sequences*/
i=j=x=0;
while(i<Nseq) {
		if(x==0) seqname[i]=lirenom(infile);
		k=0;
		while( (c=fgetc(infile))!='\n' ) {
					if(c==' ') continue;
					if(islower(c)!=0) c=toupper(c);
					if(c=='U') c='T';
					seq[i][j]=c;
					k++;
					j++;
					}
		if(k==0) continue;
		if(i<(Nseq-1)) j=j-k;
		if(i==(Nseq-1)) {
			if(j!=Nsites) i=(-1);
			x++;
			}
		i++;
		}

/*put \0 at the end of all the sequences*/
for(i=0; i<Nseq; i++) seq[i][j]='\0';
printf("\n%d sequences read.\n\n", Nseq);

v=(double *)malloc( (Nseq*(Nseq-1)/2)*sizeof(double) );


/*eliminate all positions with gaps*/
gaps=0;
for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
				if(seq[i][j]=='-') {
					gaps=1;
					if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						Nsites-=1;
						j=j-1;
						break;
						}
				}
for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';
/*for(i=0; i<Nseq; i++) {
		printf("%s\n", seqname[i]);
		for(j=0; j<Nsites; j++) printf("%c", seq[i][j]);
		printf("\n");
		}*/


if(Opt!=1) {
	/*eliminate undefined nucleotides*/

	if( (pos=(int *)malloc( Nsites*sizeof(int) ))==NULL ) {
						printf("malloc error!\n");
						exit(-1);
						}
	jjj=0;
	indice=0;
	for(i=0; i<Nseq; i++) {
		rseq[i]=(char *)malloc((Nsites+1)*sizeof(char));
		for(j=0; j<=Nsites; j++) rseq[i][j]=seq[i][j];
		}
	for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
				if(seq[i][j]!='A' && seq[i][j]!='C' && seq[i][j]!='G' && seq[i][j]!='T') {
						if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						indice+=1;
						Nsites-=1;
						pos[jjj++]=j+indice;
						j=j-1;
						break;
						}
				}
	for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';
	/*for(i=0; i<Nseq; i++) {
		printf("%s\n", seqname[i]);
		for(j=0; j<Nsites; j++) printf("%c", seq[i][j]);
		printf("\n");
		}*/

	if(indice!=0) {
		printf("Undefined nucleotides were found at positions:\n");
		for(i=0; i<indice; i++) printf("%d,", pos[i]);
		printf("\n");
		}
		
	if(indice!=0 && clear==1) {
			printf("\nYou decided to eliminate them in all sequences.\n");
			if(gaps!=0) printf("Gaps were also removed.\n");
			printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites);

			/*create and open the cleared file*/
			chname=1;
			L=strlen(infilename);
			strncpy(clearfilename, infilename, L);
			clearfilename[L]='\0';
			strcat(clearfilename, "cleared");
			L=strlen(clearfilename);
			clearfilename[L]='\0';	
			if ( (clearfile=fopen(clearfilename,"w") )==NULL) {
					fprintf(stderr, "can't open cleared file!\n");
					exit(1);
					}

			/*write all the sequences in interleaved format*/
			fprintf(clearfile, "%d  %d\n", Nseq, Nsites);
			i=l=0;
			while(i<Nsites) {
				for(j=0; j<Nseq; j++) {
					if(l==0) fprintf(clearfile, "%s", seqname[j]);
					for(k=i; (k<(i+50) && k<Nsites); k++) fprintf(clearfile, "%c", seq[j][k]);
					fprintf(clearfile, "\n");
					}
				fprintf(clearfile, "\n");
				l++;
				i+=50;
				}
			fclose(clearfile);
			}

	if( indice==0 || (indice!=0 && clear==2) ) {
		Nsites=Nsites+indice;
		for(i=0; i<Nseq; i++) for(j=0; j<=Nsites; j++) seq[i][j]=rseq[i][j];

		if(gaps!=0) {
			printf("\nGaps were removed.\n");
			printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites);

			/*create and open the cleared file*/
			chname=1;
			L=strlen(infilename);
			strncpy(clearfilename, infilename, L);
			clearfilename[L]='\0';
			strcat(clearfilename, "cleared");
			L=strlen(clearfilename);
			clearfilename[L]='\0';	
			if ( (clearfile=fopen(clearfilename,"w") )==NULL) {
					fprintf(stderr, "can't open cleared file!\n");
					exit(1);
					}

			/*write all the sequences in interleaved format*/
			fprintf(clearfile, "%d  %d\n", Nseq, Nsites);
			i=l=0;
			while(i<Nsites) {
				for(j=0; j<Nseq; j++) {
					if(l==0) fprintf(clearfile, "%s", seqname[j]);
					for(k=i; (k<(i+50) && k<Nsites); k++) fprintf(clearfile, "%c", seq[j][k]);
					fprintf(clearfile, "\n");
					}
				fprintf(clearfile, "\n");
				l++;
				i+=50;
				}
			fclose(clearfile);
			}

		for(i=0; i<Nseq; i++) free(rseq[i]);
		}
	}

if(Opt==1) {
	/*eliminate undefined amino acids*/

	if( (pos=(int *)malloc( Nsites*sizeof(int) ))==NULL ) {
						printf("malloc error!\n");
						exit(-1);
						}
	jjj=0;
	indice=0;
	for(i=0; i<Nseq; i++) {
		rseq[i]=(char *)malloc((Nsites+1)*sizeof(char));
		for(j=0; j<=Nsites; j++) rseq[i][j]=seq[i][j];
		}
	for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
				if(seq[i][j]=='B' || seq[i][j]=='J' || seq[i][j]=='O' || seq[i][j]=='U' || seq[i][j]=='X' || seq[i][j]=='Z' || seq[i][j]=='*') {
						if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						indice+=1;
						Nsites-=1;
						pos[jjj++]=j+indice;
						j=j-1;
						break;
						}
				}
	for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';
	/*for(i=0; i<Nseq; i++) {
		printf("%s\n", seqname[i]);
		for(j=0; j<Nsites; j++) printf("%c", seq[i][j]);
		printf("\n");
		}*/

	if(indice!=0) {
		printf("Undefined amino acids were found at positions:\n");
		for(i=0; i<indice; i++) printf("%d,", pos[i]);
		printf("\n");
		}
		
	if(indice!=0 && clear==1) {
			printf("\nYou decided to eliminate them in all sequences.\n");
			if(gaps!=0) printf("Gaps were also removed.\n");
			printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites);

			/*create and open the cleared file*/
			chname=1;
			L=strlen(infilename);
			strncpy(clearfilename, infilename, L);
			clearfilename[L]='\0';
			strcat(clearfilename, "cleared");
			L=strlen(clearfilename);
			clearfilename[L]='\0';	
			if ( (clearfile=fopen(clearfilename,"w") )==NULL) {
					fprintf(stderr, "can't open cleared file!\n");
					exit(1);
					}

			/*write all the sequences in interleaved format*/
			fprintf(clearfile, "%d  %d\n", Nseq, Nsites);
			i=l=0;
			while(i<Nsites) {
				for(j=0; j<Nseq; j++) {
					if(l==0) fprintf(clearfile, "%s", seqname[j]);
					for(k=i; (k<(i+50) && k<Nsites); k++) fprintf(clearfile, "%c", seq[j][k]);
					fprintf(clearfile, "\n");
					}
				fprintf(clearfile, "\n");
				l++;
				i+=50;
				}
			fclose(clearfile);
			}

	if( indice==0 || (indice!=0 && clear==2) ) {
		Nsites=Nsites+indice;
		for(i=0; i<Nseq; i++) for(j=0; j<=Nsites; j++) seq[i][j]=rseq[i][j];

		if(gaps!=0) {
			printf("\nGaps were removed.\n");
			printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites);

			/*create and open the cleared file*/
			chname=1;
			L=strlen(infilename);
			strncpy(clearfilename, infilename, L);
			clearfilename[L]='\0';
			strcat(clearfilename, "cleared");
			L=strlen(clearfilename);
			clearfilename[L]='\0';	
			if ( (clearfile=fopen(clearfilename,"w") )==NULL) {
					fprintf(stderr, "can't open cleared file!\n");
					exit(1);
					}

			/*write all the sequences in interleaved format*/
			fprintf(clearfile, "%d  %d\n", Nseq, Nsites);
			i=l=0;
			while(i<Nsites) {
				for(j=0; j<Nseq; j++) {
					if(l==0) fprintf(clearfile, "%s", seqname[j]);
					for(k=i; (k<(i+50) && k<Nsites); k++) fprintf(clearfile, "%c", seq[j][k]);
					fprintf(clearfile, "\n");
					}
				fprintf(clearfile, "\n");
				l++;
				i+=50;
				}
			fclose(clearfile);
			}

		for(i=0; i<Nseq; i++) free(rseq[i]);
		}
	}


/*create and open the output file ".num" */
if(chname==1) {
	L=strlen(clearfilename);
	strncpy(outfilename, clearfilename, L);
	}
else {
	L=strlen(infilename);
	strncpy(outfilename, infilename, L);
	}
outfilename[L]='\0';
if(R==1) strcat(outfilename, "bin.num");
else strcat(outfilename, "nc.num");
L=strlen(outfilename);
outfilename[L]='\0';	
if ( (outfile=fopen(outfilename,"w") )==NULL) {
				fprintf(stderr, "can't open output file!\n");
				exit(1);
				}

if(Opt==3 && transiversions==1) {
			/*create and open the output file ".transi" */
			if(chname==1) {
				L=strlen(clearfilename);
				strncpy(transifilename, clearfilename, L);
				}
			else {
				L=strlen(infilename);
				strncpy(transifilename, infilename, L);
				}
			transifilename[L]='\0';
			if(R==1) strcat(transifilename, "bin.transi");
			else strcat(transifilename, "nc.transi");
			L=strlen(transifilename);
			transifilename[L]='\0';	
			if ( (transifile=fopen(transifilename,"w") )==NULL) {
					fprintf(stderr, "can't open transitions file!\n");
					exit(1);
					}
			/*create and open the output file ".transver" */
			if(chname==1) {
				L=strlen(clearfilename);
				strncpy(transverfilename, clearfilename, L);
				}
			else {
				L=strlen(infilename);
				strncpy(transverfilename, infilename, L);
				}
			transverfilename[L]='\0';
			if(R==1) strcat(transverfilename, "bin.transver");
			else strcat(transverfilename, "nc.transver");
			L=strlen(transverfilename);
			transverfilename[L]='\0';	
			if ( (transverfile=fopen(transverfilename,"w") )==NULL) {
					fprintf(stderr, "can't open transversions file!\n");
					exit(1);
					}
			dtt=(double *)malloc( 2*sizeof(double) );
			if(dtt==NULL) {
				printf("memory error!\n");
				exit(-44);
				}
			}


/*printf("Do you want to exclude some sites (Yes=1, No=2)?\n");
scanf("%d", &excl);*/
excl=2;

if(excl==1) {
	printf("What's the name of the file containing the excluded sites?\n");
	scanf("%s", excludefilename);

	/*open exclusion file*/
	if( (excludefile=fopen(excludefilename, "r"))==NULL) {
				printf("can't open exclusion file!\n");
				exit(1);
				}

	exclu=0;
	while( fscanf(excludefile, "%d", &exsite)!=EOF ) {
					if(exsite==0 || exsite>Nsites) {
								printf("ERROR: the site %d does not exist!\n", exsite);
								exit(-1);
								}
					for(i=0; i<Nseq; i++) seq[i][exsite-1]='&';
					exclu++;
					}
	printf("\n%d sites are excluded.\n", exclu);
	printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites-exclu);

	jjj=0;
	indice=0;
	for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
					if(seq[i][j]=='&') {
						if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						indice+=1;
						Nsites-=1;
						j=j-1;
						break;
						}
					}
	for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';

	/*create and open the excluded file*/
	L=strlen(infilename);
	strncpy(exoutfilename, infilename, L);
	exoutfilename[L]='\0';
	strcat(exoutfilename, "excluded");
	L=strlen(exoutfilename);
	exoutfilename[L]='\0';	
	if ( (exoutfile=fopen(exoutfilename,"w") )==NULL) {
					fprintf(stderr, "can't open excluded file\n");
					exit(1);
					}
	/*write all the sequences in interleaved format*/
			fprintf(exoutfile, "%d  %d\n", Nseq, Nsites);
			i=l=0;
			while(i<Nsites) {
				for(j=0; j<Nseq; j++) {
					if(l==0) fprintf(exoutfile, "%s", seqname[j]);
					for(k=i; k<(i+50) && k<Nsites; k++) fprintf(exoutfile, "%c", seq[j][k]);
					fprintf(exoutfile, "\n");
					}
				fprintf(exoutfile, "\n");
				l++;
				i+=50;
				}

	fclose(excludefile);
	fclose(exoutfile);
	}



if(Opt==1 && R==2 && empiri==1) dist=1;
else if(Opt==1 && R==2 && empiri==2) dist=2;
else if(Opt==1 && R==1 && kind!=1) dist=3;
else if(Opt==1 && R==1 && kind==1) dist=4;
else if(Opt==2 && R==2) dist=5;
else if(Opt==2 && R==1 && kind!=1) dist=6;
else if(Opt==2 && R==1 && kind==1) dist=7;
else if(Opt==3 && R==2) dist=8;
else if(Opt==3 && R==1 && kind!=1) dist=9;
else if(Opt==3 && R==1 && kind==1) dist=10;
else if(Opt==4 && R==2) dist=11;
else if(Opt==4 && R==1 && kind!=1) dist=12;
else if(Opt==4 && R==1 && kind==1) dist=13;
else dist=14;


fprintf(outfile, "  %d\n", Nseq);
if(transiversions==1) {
		fprintf(transifile, "  %d\n", Nseq);
		fprintf(transverfile, "  %d\n", Nseq);
		}

u=0;
sum=0;
max=0;
for(i=0;i<(Nseq-1);i++) {
		l=1;
		/*fprintf(outfile, "%.10s", seqname[i]);*/
		for(j=(i+1);j<Nseq;j++) {
				p=0.0;  /*transitional differences*/
				q=0.0;  /*transversional differences*/
				P=0.0;  /*differences for protein sequences*/
				compt=0;
				for(k=0;k<Nsites;k++) {
						c1=seq[i][k];
						c2=seq[j][k];
						if(Opt==1) {
							if( (c1=='B' || c1=='J' || c1=='O' || c1=='U' || c1=='X' || c1=='Z' || c1=='*') || (c2=='B' || c2=='J' || c2=='O' || c2=='U' || c2=='X' || c2=='Z' || c2=='*') ) compt++;
							else if(c1!=c2) P=P+1;
							}
						else {
							if( (c1!='A' && c1!='C' && c1!='G' && c1!='T' && c1!='R' && c1!='Y') || (c2!='A' && c2!='C' && c2!='G' && c2!='T' && c2!='R' && c2!='Y') ) compt++;
							if( (c1=='R' && c2=='R') || (c1=='Y' && c2=='Y') ) {
												if(JCtransversions==2) compt++;
												}
							if( ((c1=='A' || c1=='G') && c2=='R') || ((c2=='A' || c2=='G') && c1=='R') ) {
	if(JCtransversions==2) compt++;
	}
							if( ((c1=='C' || c1=='T') && c2=='Y') || ((c2=='C' || c2=='T') && c1=='Y') ) {
	if(JCtransversions==2) compt++;
	}
							if( (c1=='A' || c1=='C' || c1=='G' || c1=='T') && (c2=='A' || c2=='C' || c2=='G' || c2=='T') ) if(c1!=c2) {
				if( (c1=='A' && c2=='G')||(c1=='G' && c2=='A')||(c1=='C' && c2=='T')||(c1=='T' && c2=='C') ) p=p+1;
				else q=q+1;
				}
							if( ((c1=='R' || c1=='A' || c1=='G') && c2=='Y') || ((c2=='R' || c2=='A' || c2=='G') && c1=='Y') ) q=q+1;
							if( ((c1=='Y' || c1=='C' || c1=='T') && c2=='R') || ((c2=='Y' || c2=='C' || c2=='T') && c1=='R') ) q=q+1;
							}
						}
				if(compt>max) max=compt;
				sum+=compt;
				/* printf("compt=%d", compt); */
				/* printf("%f %f %f\n", P, p, q); */
				if(R==1 && invar==1) {
					p=(p/( (Nsites-compt)*(1-t) ));
					q=(q/( (Nsites-compt)*(1-t) ));
					P=(P/( (Nsites-compt)*(1-t) ));
					}
				else {
					p=(p/(Nsites-compt));
					q=(q/(Nsites-compt));
					P=(P/(Nsites-compt));
					}
				/*if(Opt==1) printf("P=%f\n", P);
				else printf("p=%f, q=%f p+q=%f, ", p, q, p+q);*/
				/*if(p==0.0 && q!=0.0) printf("p==0 et q!=0,");*/
				if(Opt==3) {
					if(R==1) {
						trsver=0.125*a*( pow((1-2*q), -1.0/a) - 1 );
						transi=0.25*a*( pow((1-2*p-q), -1.0/a) - 0.5*pow((1-2*q), -1.0/a) - 0.5 );
						}
					else {
						trsver=-0.125*log(1-2*q);
						transi=-0.25*log(1-2*p-q)+0.125*log(1-2*q);
						}
					/*printf("a/b=%f\n", transi/trsver);*/
					}

				switch(dist) {
				case 1:
					d=otaneicont(P, 2, 1);
					break;
				case 2:
					d=otaneicont(P, 2, 2);
					v[u]=varotaneicont(P, Nsites-compt, 2); 
					break;
				case 3:
					d=otaneicont(P, 1, 2);
					if(invar==1) v[u]=varotaneicont(P, (Nsites-compt)*(1-t), 1);
					else v[u]=varotaneicont(P, Nsites-compt, 1);
					break;
				case 4:
					d=truncnegbinprodist(P);
					break;
				case 5:
					d=neigojocont(p+q, 2);
					v[u]=varneigojocont(p+q, Nsites-compt, 2);
					break;
				case 6:
					d=neigojocont(p+q, 1);
					if(invar==1) v[u]=varneigojocont(p+q, (Nsites-compt)*(1-t), 1);
					else v[u]=varneigojocont(p+q, Nsites-compt, 1);
					break;
				case 7:
					d=truncnegbinjcdist(p+q);
					break;
				case 8:
					d=jinneicont(p, q, 2);
					v[u]=varjinneicont(p, q, Nsites-compt, 2);
					if(transiversions==1) dtt=jinneitransiversions(p, q, 2);
					break;
				case 9:
					d=jinneicont(p, q, 1);
					if(invar==1) v[u]=varjinneicont(p, q, (Nsites-compt)*(1-t), 1);
					else v[u]=varjinneicont(p, q, Nsites-compt, 1);
					if(transiversions==1) dtt=jinneitransiversions(p, q, 1);
					break;
				case 10:
					d=truncnegbinkimdist(p, q);
					if(transiversions==1) dtt=truncnegbintransiversions(p, q);
					break;
				case 11:
					d=neigojotransvercont(q, 2);
					break;
				case 12:
					d=neigojotransvercont(q, 1);
					break;
				case 13:
					d=truncnegbinjctransverdist(q);
					break;
				default:
					printf("impossible option!\n");
					exit(-1);
				}
				u++;
				if(d==-15000.0) fprintf(outfile, "   NaN");
				else fprintf(outfile, "   %f", d);
				if(transiversions==1) {
					if(dtt[0]==-15000.0) fprintf(transverfile, "   NaN");
					else fprintf(transverfile, "   %f", dtt[0]);
					if(dtt[1]==-15000.0) fprintf(transifile, "   NaN");
					else fprintf(transifile, "   %f", dtt[1]);
					}
				if(l==7 && j!=(Nseq-1)) {
					fprintf(outfile, "\n");
					if(transiversions==1) {
							fprintf(transverfile, "\n");
							fprintf(transifile, "\n");
							}
					l=0;
					}
				l++;
				}
		fprintf(outfile, "\n");
		if(transiversions==1) {
				fprintf(transverfile, "\n");
				fprintf(transifile, "\n");
				}
		}
	/*fprintf(outfile, "%.10s", seqname[Nseq-1]);*/
	fprintf(outfile, "\n");
	if(transiversions==1) {
			fprintf(transverfile, "\n");
			fprintf(transifile, "\n");
			}

	if(max!=0) printf("in average, %.0f undefined sites were excluded.\nthe maximal number of undefined sites excluded is %d\n", (float)sum/u, max);
	printf("(%d comparisons)\n", u);


	/*write the names of the sequences below the matrix to */
	/*complete the ".num" format*/
	if(dist==1) fprintf(outfile, "Option: Kimura.prot(empirical)\n");
	if(dist==2) fprintf(outfile, "Option: Poisson, -ln(1-P)\n");
	if(dist==3) {
		if(invar==1) fprintf(outfile, "Option: Ota/Nei(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(outfile, "Option: Ota/Nei(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==4) fprintf(outfile, "Option: Ota/Nei(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	if(dist==5) fprintf(outfile, "Option: Jukes/Cantor\n");
	if(dist==6) {
		if(invar==1) fprintf(outfile, "Option: Jukes/Cantor(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(outfile, "Option: Jukes/Cantor(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==7) fprintf(outfile, "Option: Jukes/Cantor(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	if(dist==8) fprintf(outfile, "Option: Kimura\n");
	if(dist==9) {
		if(invar==1) fprintf(outfile, "Option: Kimura(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(outfile, "Option: Kimura(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==10) fprintf(outfile, "Option: Kimura(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	if(dist==11) fprintf(outfile, "Option: Jukes/Cantor-transversions\n");
	if(dist==12) {
		if(invar==1) fprintf(outfile, "Option: Jukes/Cantor-transversions(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(outfile, "Option: Jukes/Cantor-transversions(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==13) fprintf(outfile, "Option: Jukes/Cantor-transversions(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	j=1;
	for(i=0; i<Nseq; i++) {			
			fprintf(outfile, "%-20.20s", seqname[i]);
			if(j==4) {
				fprintf(outfile, "\n");
				j=0;
				}
			j++;
			}
	fprintf(outfile, "\n\n");

if(transiversions==1) {
	/*write the names of the sequences below the matrix to */
	/*complete the ".transver" format*/
	if(dist==8) fprintf(transverfile, "Option: Kimura\n");
	if(dist==9) {
		if(invar=1) fprintf(transverfile, "Option: Kimura(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(transverfile, "Option: Kimura(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==10) fprintf(transverfile, "Option: Kimura(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	j=1;
	for(i=0; i<Nseq; i++) {			
			fprintf(transverfile, "%-20.20s", seqname[i]);
			if(j==4) {
				fprintf(transverfile, "\n");
				j=0;
				}
			j++;
			}
	fprintf(transverfile, "\n\n");

	/*write the names of the sequences below the matrix to */
	/*complete the ".transi" format*/
	if(dist==8) fprintf(transifile, "Option: Kimura\n");
	if(dist==9) {
		if(invar==1) fprintf(transifile, "Option: Kimura(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		else fprintf(transifile, "Option: Kimura(continuous gamma) with a=%.3f\n", a);
		}
	if(dist==10) fprintf(transifile, "Option: Kimura(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
	j=1;
	for(i=0; i<Nseq; i++) {			
			fprintf(transifile, "%-20.20s", seqname[i]);
			if(j==4) {
				fprintf(transifile, "\n");
				j=0;
				}
			j++;
			}
	fprintf(transifile, "\n\n");
	}


	/*printf("Do you want to compute the variances of the distances (Yes=1, No=2)?\n");
	scanf("%d", &printvar);*/
	printvar=2;
	if(printvar==1) {
		/*print the variances below the distances in ".num" format*/
		if(dist==2 || dist==3 || dist==5 || dist==6 || dist==8 || dist==9) {
						fprintf(outfile, "Variances:\n");
						fprintf(outfile, "  %d\n", Nseq);
						for(u=0,i=0; i<Nseq-1; i++) {
								l=1;
								for(j=i+1; j<Nseq; j++,u++) {
									fprintf(outfile, "   %f", v[u]);
									if( l==7 && j!=(Nseq-1) ) {
											fprintf(outfile, "\n");
											l=0;
											}
									l++;
									}
								fprintf(outfile, "\n");
								}
						fprintf(outfile, "\n");
						/*write the names of the sequences below the matrix to */
						/*complete the ".num" format*/
						if(dist==2) fprintf(outfile, "Option: Poisson, -ln(1-P)\n");
						if(dist==3) fprintf(outfile, "Option: Ota/Nei(continuous gamma)\n");
						if(dist==5) fprintf(outfile, "Option: Jukes/Cantor\n");
						if(dist==6) fprintf(outfile, "Option: Jukes/Cantor(continuous gamma)\n");
						if(dist==8) fprintf(outfile, "Option: Kimura\n");
						if(dist==9) fprintf(outfile, "Option: Kimura(continuous gamma)\n");

						j=1;
						for(i=0; i<Nseq; i++) {			
							fprintf(outfile, "%-20.20s", seqname[i]);
							if(j==4) {
								fprintf(outfile, "\n");
								j=0;
								}
							j++;
							}
						}
		}



for(i=0; i<Nseq; i++) {
			free(seqname[i]);
			free(seq[i]);
			}


fclose(infile);
fclose(outfile);
if(transiversions==1) {
	fclose(transverfile);
	fclose(transifile);
	}

return 0;
}


/*function which reads the name of one sequence only*/
char *lirenom(FILE *infile)
{
char *nom;
int i, c;

/*allocate memory for the pointer nom */
if( (nom=(char*)malloc( (nmlngth+1)*sizeof(char)) )==NULL ) {
				printf("not enough memory\n");
				exit(1);
				}

/*read the name of the sequence*/
i=0;
while(i<nmlngth) {
	c=fgetc(infile);
	if(c=='\n') continue;
	nom[i]=c;
	i++;
	}
nom[i]='\0';

return nom;
}


/*function which calculates the distance of Ota and Nei
(modification of the Poisson distance for protein sequences using a
continuous gamma distribution)*/
double otaneicont(double p, int R, int empiri)
{
extern double a;
double d;
double x, y;

x=1-p;

if(R==2) {
	if(empiri==1) d=-log( x-(0.2*p*p) );
	else d=-log(x);
	}
else {
	y=pow( x, (-1.0/a) );
	d=a*(y-1);
	}

return d;
}


/*function which calculates the distance of Nei and Gojobori
(modification of the Jukes-and-Cantor's distance for nucleic sequences using a
continuous gamma distribution)*/ 
double neigojocont(double p, int R)
{
extern double a;
double d;
double x, y, z;

x=(4.0/3.0)*p;

if(R==2) {
	y=log(1-x);
	d=-(3.0/4.0)*y;
	}
else {
	y=pow( (1-x), (-1.0/a) );
	z=(3.0/4.0)*a;
	d=z*(y-1);
	}

return d;
}

/*function which calculates the transversional distance of Nei and Gojobori
(modification of the Jukes-and-Cantor's distance for nucleic sequences and
for transversions only using a continuous gamma distribution)*/
double neigojotransvercont(double q, int R)
{
extern double a;
double d;
double x, y, z;

x=2*q;

if(R==2) {
	y=log(1-x);
	d=-(1.0/2.0)*y;
	}
else {
	y=pow( (1-x), (-1.0/a) );
	z=(1.0/2.0)*a;
	d=z*(y-1);
	}

return d;
}


/*function which calculates the distance of Jin and Nei
(modification of the Kimura's distance for nucleic sequences using a
continuous gamma distribution)*/
double jinneicont(double p, double q, int R)
{
extern double a;
double d;
double x, y, z, z1, z2;

x=(1-(2*p)-q);
y=(1-(2*q));

if(R==2) {
	z=log( x*sqrt(y) );
	if(p==0.0) d=-(1.0/2.0)*log(y);
	else d=-(1.0/2.0)*z;
	}
else {
	z1=pow(x, (-1.0/a));
	z2=pow(y, (-1.0/a));
	if(p==0.0) d=-(1.0/2.0)*(z1-1);
	else d=(a/2.0)*( z1+(z2/2)-(3.0/2) );
	}

return d;
}

/*function which calculates the distance of Jin and Nei
(modification of the Kimura's distance for nucleic sequences using a
continuous gamma distribution).
This function separates the transitional and transversional parts of
the distance*/
double *jinneitransiversions(double p, double q, int R)
{
extern double a;
double *d;
double x, y, z, z1, z2;

d=(double *)malloc( 2*sizeof(double) );
if(d==NULL) {
	printf("memory error!\n");
	exit(-44);
	}

x=(1-(2*p)-q);
y=(1-(2*q));

if(R==2) {
	d[0]=-(1.0/4)*log(y)*2;
	d[1]=-(1.0/2)*log(x)-(1.0/2)*d[0];
	if(q==0.0) d[0]=0.0;
	if(p==0.0) d[1]=0.0;
	/*printf("a/b=%f\n", 2*d[1]/d[0]);*/
	}
else {
	z1=pow(x, (-1.0/a));
	z2=pow(y, (-1.0/a));
	d[0]=(1.0/4)*(z2-1)*2;
	d[1]=(1.0/2)*(z1-1)-(1.0/2)*d[0];
	if(q==0.0) d[0]=0.0;
	if(p==0.0) d[1]=0.0;
	/*printf("a/b=%f\n", 2*d[1]/d[0]);*/
	}

return d;
}


/*function which calculates the variance of the distance of Ota and Nei*/
double varotaneicont(double p, double N, int R)
{
extern double a;
double v;
double x, y;

if(R==2) v=p/( (1-p)*N );
else {
	x=1-p;
	y=pow( x, -(1+2.0/a) );
	v=(p*y)/N;
	}

return v;
}


/*function which calculates the variance of the distance of Nei and Gojobori*/
double varneigojocont(double p, double N, int R)
{
extern double a;
double v;
double x, y, z;

x=(3-4*p)*(3-4*p);
v=9*p*(1-p)/x;

if(R==2) return v/N;
else {
	y=1-(4.0/3)*p;
	z=pow( y, (-2.0/a) );
	v=v*z;
	return v/N;
	}

}

/*function which calculates the variance of the distance of Jin and Nei*/
double varjinneicont(double p, double q, double N, int R)
{
extern double a;
double v;
double x, y, z, z1, z2;

x=(1-(2*p)-q);
y=(1-(2*q));

if(R==2) {
	z1=1.0/x;
	z=1.0/y;
	z2=(1.0/2)*(z1+z);
	}
else {
	z1=pow(x, (-1.0/a + 1));
	z=pow(y, (-1.0/a + 1));
	z2=(1.0/2)*(z1+z);
	}

v=(z1*z1)*p + (z2*z2)*q - (z1*p+z2*q)*(z1*p+z2*q);

return v/N;
}

/*function which calculates the Jukes-and-Cantor-like distance of Tourasse
and Gouy (modification of the Jukes-and-Cantor's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/ 
double truncnegbinjcdist(double p)
{
double d, V, Z, temp1, temp2, temp3, temp4;
double z=1;

/*printf("z?\n");
scanf("%lf", &z);
printf("z=%f\n", z);*/

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-(4.0/3)*p;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-(3.0/4)*MOY*log(temp4)/z;

return d;
}

/*function which calculates the transversional Jukes-and-Cantor-like distance of
Tourasse and Gouy (modification of the Jukes-and-Cantor's distance for nucleic
sequences and for transversions only using an Invariant+Truncated Negative
Binomial distribution)*/ 
double truncnegbinjctransverdist(double q)
{
double d, V, Z, temp1, temp2, temp3, temp4;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-2*q;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-(1.0/2)*MOY*log(temp4);

return d;
}

/*function which calculates the Kimura-like distance of Tourasse
and Gouy (modification of the Kimura's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/ 
double truncnegbinkimdist(double p, double q)
{
double d1, d2, V, Z1, Z2, temp1, temp2, temp3, temp4, temp5, temp6, temp7;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-2*q;
Z1=temp1*temp2;
temp3=1-2*p-q;
Z2=temp1*temp3;

temp4=pow(Z1+1,(-1.0/a));
temp5=pow(Z2+1,(-1.0/a));
temp6=((1+b)/b)*(1-temp4);
temp7=((1+b)/b)*(1-temp5);

d1=-(1.0/4)*MOY*log(temp6);
d2=-(1.0/2)*MOY*log(temp7);
if(q==0.0) d1=0.0;
if(p==0.0) d2=d1;
/*printf("p=%f, q=%f, dv(=2*d1)=%f, d2=%f, ds=%f, a/b=%f\n", p, q, 2*d1, d2, d2-d1, (d2-d1)/d1);*/

return d1+d2;
}

/*function which calculates the Kimura-like distance of Tourasse
and Gouy (modification of the Kimura's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution).
This function separates the transitional and transversional parts of
the distance*/
double *truncnegbintransiversions(double p, double q)
{
double *d, d2, V, Z1, Z2, temp1, temp2, temp3, temp4, temp5, temp6, temp7;

d=(double *)malloc( 2*sizeof(double) );
if(d==NULL) {
	printf("memory error!\n");
	exit(-44);
	}

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-2*q;
Z1=temp1*temp2;
temp3=1-2*p-q;
Z2=temp1*temp3;

temp4=pow(Z1+1,(-1.0/a));
temp5=pow(Z2+1,(-1.0/a));
temp6=((1+b)/b)*(1-temp4);
temp7=((1+b)/b)*(1-temp5);

d[0]=-(1.0/4)*MOY*log(temp6)*2;
d2=-(1.0/2)*MOY*log(temp7);
if(q==0.0) d[0]=0.0;
if(p==0.0) d2=(1.0/2.0)*d[0];
d[1]=d2-(1.0/2)*d[0];

/*printf("a/b=%f\n", 2*d[1]/d[0]);*/

return d;
}

/*function which calculates the Ota-and-Nei-like distance of Tourasse and Gouy
(modification of the Poisson distance for protein sequences using an
Invariant+Truncated Negative Binomial distribution)*/
double truncnegbinprodist(double P)
{
double d, V, Z, temp1, temp2, temp3, temp4;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-P;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-MOY*log(temp4);

return d;
}
