#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 1000
#define MAXSEQ 500   /*maximum number of sequences read*/
#define nmlngth 10   /*number of characters in a species name*/


/*prototypes*/
char *lireseq(FILE *, int);
char *lirenom(FILE *);
void newseq(FILE *, int, int, char **, char **);
char *newname(FILE *);
int translate(char, char, char);
double numsites(char, char, char);
double inasites(char, char, char, double, double);
int *termsites(char, char, char);
double *yangsites(char, char, char, char, char, char);
double transition(char, char);
double variancejc(int, double *, double *, double, double, double, double, int, int);
double variancekim(int, double *, double *, double *, double, double, double, double, double, int, int);
void printnum(FILE *, int, char *[], double *, int, int, int);
double truncnegbinjcdist(double p);
double truncnegbinkimdist(double p, double q);


double a, b, t, MOY;
int kind;
int JCtransversions=2;
double *dd[MAXSEQ];


int main(int argc, char *argv[])
{
char infilename[40], outfilename1[40], outfilename2[40];
char excludefilename[40], exoutfilename[40], clearfilename[40];
FILE *infile, *outfile1, *outfile2;
FILE *excludefile, *exoutfile, *clearfile;
char *seq[MAXSEQ];
char *seqname[MAXSEQ];
char line[MAX+1];
int Nseq, Nsites, Ncompar;
int i, j, jj, jjj, k, l, v, w, c1, c2, c3;
char mutant1, mutant2, mutant3;
double x, y, x1, x2, y1, y2, z1, z2, ax, ay, ax1, ax2, ay1, ay2, az1, az2;
double xx, yy, xx1, xx2, yy1, yy2, zz1, zz2, axx, ayy, axx1, axx2, ayy1, ayy2, azz1, azz2;
double Nd, *nd, Ad, *ad, *bd, Pn, An, Bn, *dn, *varn, N, Nmoy, Nm, *n;   /*nonsynonymous variables*/
double Sd, *sd, As, *as, *bs, Ps, Cs, Ds, *ds, *vars, S, Smoy, Sm, *s;    /*synonymous variables*/
double transi, trsver, P, Q, tot, *asurbmoy, N1, N2, n1, n2, TotalSites, *nterm;
int index, ind, aa1, aa2;
int L;
int stop, biz;
int R, r, ina, yang, dist, invar, printvar;
int interleaved, format;
long int position;
int compt, indice;
int excl, exclu, exsite, gaps, chname;
int phylip, Opt;
double d;

printf("*******************************************************\n");
printf("<<Program NEIGOJINA: computes evolutionary distances>>\n");
printf("<<between codons using the method of Nei and Gojobori.>>\n\n");


/*if(argc>1)*/ strcpy(infilename, argv[1]);
/*open input file*/
/*printf("input name of sequences file? (sequential or interleaved phylip format)\n");
scanf("%s", infilename);*/
if( (infile=fopen(infilename, "r"))==NULL) {
				printf("can't open input file\n");
				exit(1);
				}
chname=0;

printf("\nChoose the distance you want to use: (input a number)\n");
/*printf("Jukes-and-Cantor-like?        1\nKimura-like?                  2\nTransversional distance?      3\n");*/
printf("Jukes-and-Cantor-like?        1\nKimura-like?                  2\n");
scanf("%d", &Opt);

if(Opt==2) r=1;
if(Opt==1) r=2;
if(Opt==3) {
		r=2;
		JCtransversions=1;
		}

printf("Do you want to correct the distances for rate variation among sites? (Yes=1, No=2)\n");
scanf("%d", &R);
if(R==1) {
	printf("What kind of distribution do you want to use ? (enter a number)\n");
	printf("Invariant + truncated negative binomial?  <1>\n");
	printf("Continuous gamma?                         <2>\n");
	printf("Invariant + continuous gamma              <3>\n");
	scanf("%d", &kind);

	if(kind==1) {
		printf("What's the mean of the observed distribution?\n");
		scanf("%lf", &MOY);
		printf("MOY=%f\n", MOY);
		}

	printf("What's the value of a?\n");
	scanf("%lf", &a);
	printf("a=%f\n", a);

	if(kind==1) 
		{
		printf("What's the value of b?\n");
		scanf("%lf", &b);
		printf("b=%f\n", b);
		}

	/*printf("Do you want to take into account the invariant sites (Yes=1, No=2)?\n");
	scanf("%d", &invar);*/
	if(kind==1 || kind==3) invar=1;
	else invar=2;
	if(invar==1) {
		printf("What's the value of t?\n");
		scanf("%lf", &t);
		printf("t=%f\n", t);
		}
	
	}

printf("Do you want to compute:\nsynonymous distances?      <1>\nnonsynonymous distances?   <2>\n");
scanf("%d", &dist);

/*printf("Do you want to use the method of Yang for computing the number of synonymous and nonsynonymous sites? (Yes=1, No=2)\n");
scanf("%d", &yang);*/
yang=2;
if(r==1 && JCtransversions==2 && yang==2) {
		/*printf("Do you want to use the method of Ina for computing the number of synonymous and nonsynonymous sites? (Yes=1, No=2)\n");
		scanf("%d", &ina);*/
		ina=2;
		}


/*read the header*/
fscanf(infile, "%d", &Nseq);  
fscanf(infile, "%d", &Nsites);
/*printf("%d, %d\n", Nseq, Nsites);*/
if(Nsites%3 != 0) {
		printf("Error: the number of sites (%d) is not a multiple of 3!\n", Nsites);
		exit(5);
		}
/*read the end of the header line*/
if( (fgets(line, MAX, infile))==NULL ) {
					printf("err_fgets\n");
					exit(1);
					}


Ncompar=Nseq*(Nseq-1)/2;
ds=(double *)malloc( Ncompar*sizeof(double) );
vars=(double *)malloc( Ncompar*sizeof(double) );
dn=(double *)malloc( Ncompar*sizeof(double) );
varn=(double *)malloc( Ncompar*sizeof(double) );
sd=(double *)malloc( (Nsites/3)*sizeof(double) );
as=(double *)malloc( (Nsites/3)*sizeof(double) );
bs=(double *)malloc( (Nsites/3)*sizeof(double) );
nd=(double *)malloc( (Nsites/3)*sizeof(double) );
ad=(double *)malloc( (Nsites/3)*sizeof(double) );
bd=(double *)malloc( (Nsites/3)*sizeof(double) );
n=(double *)malloc( (Nsites/3)*sizeof(double) );
s=(double *)malloc( (Nsites/3)*sizeof(double) );

for(i=0; i<Nseq; i++) dd[i]=(double *)malloc( Nseq*sizeof(double) );

/*old=sequential format, new=interleaved format*/
position=ftell(infile);
	interleaved=0;
	for(i=0; i<=20; i++) {
		format=fgetc(infile);
		if(format=='\n') {
			fseek(infile, position, 0);
			/*read all the sequences in old phylip format*/
			for(j=0; j<Nseq; j++) {
				seqname[j]=lirenom(infile);
				seq[j]=lireseq(infile, Nsites);
				}
			interleaved=1;
			break;
			}
		}
	if(interleaved!=1) {
			fseek(infile, position, 0);
			newseq(infile, Nseq, Nsites, seq, seqname); /*read all the sequences in new phylip format*/
			}

printf("\n%d sequences read.\n\n", Nseq);

/*search for gaps, undetermined nucleotides and stop codons*/
for(i=0; i<Nseq; i++) for(j=2; j<Nsites; j+=3) {
		biz=0;
		c1=seq[i][j-2]; c2=seq[i][j-1]; c3=seq[i][j];
		if(c1!='A' && c1!='C' && c1!='G' && c1!='T') {
			if(c1!='-') printf("undefined nucleotide at position %d of the sequence %s\n", j-2+1, seqname[i]);
			biz=1;
			}
		if(c2!='A' && c2!='C' && c2!='G' && c2!='T') {
			if(c2!='-') printf("undefined nucleotide at position %d of the sequence %s\n", j-1+1, seqname[i]);
			biz=1;
			}
		if(c3!='A' && c3!='C' && c3!='G' && c3!='T') {
			if(c3!='-') printf("undefined nucleotide at position %d of the sequence %s\n", j+1, seqname[i]);
			biz=1;
			}
		if(biz==0) {
			aa1=translate(seq[i][j-2],seq[i][j-1],seq[i][j]);
			if(aa1==21) {
				printf("stop codon in positions %d,%d,%d of the sequence %s\n", j-2+1, j-1+1, j+1, seqname[i]);
				biz=1;
				}
			}
		if(biz==1) seq[i][j-2]=seq[i][j-1]=seq[i][j]='-';
		}

/*eliminate all undefined positions*/
gaps=0;
for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
				if(seq[i][j]=='-') {
					gaps=1;
					if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						Nsites-=1;
						j=j-1;
						break;
						}
				}
for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';
/*for(i=0; i<Nseq; i++) printf("nom=%s, %s\n", seqname[i], seq[i]);*/
if(Nsites%3 != 0) {
		printf("Error: the number of sites (%d) is not a multiple of 3!\n", Nsites);
		exit(5);
		}

if(gaps!=0) {
	printf("\nGaps and/or stop codons and/or undefined nucleotides were found and then eliminated in all sequences.\n");
	printf("Thus, the actual number of sites used is then %d\n\n", Nsites);

	/*create and open the cleared file*/
	chname=1;
	L=strlen(infilename);
	strncpy(clearfilename, infilename, L);
	clearfilename[L]='\0';
	strcat(clearfilename, "cleared");
	L=strlen(clearfilename);
	clearfilename[L]='\0';	
	if ( (clearfile=fopen(clearfilename,"w") )==NULL) {
					fprintf(stderr, "can't open cleared file!\n");
					exit(1);
					}

	/*write all the sequences in new format*/
	fprintf(clearfile, "%d  %d\n", Nseq, Nsites);
	i=l=0;
	while(i<Nsites) {
		for(j=0; j<Nseq; j++) {
				if(l==0) fprintf(clearfile, "%s", seqname[j]);
				for(k=i; (k<(i+50) && k<Nsites); k++) fprintf(clearfile, "%c", seq[j][k]);
				fprintf(clearfile, "\n");
				}
			fprintf(clearfile, "\n");
			l++;
			i+=50;
			}
	fclose(clearfile);
	}

/*create and open the output file ".num" for synonymous distances*/
if(dist==1) {
	if(chname==1) {
		L=strlen(clearfilename);
		strncpy(outfilename1, clearfilename, L);
		}
	else {
		L=strlen(infilename);
		strncpy(outfilename1, infilename, L);
		}
	outfilename1[L]='\0';
	if(R==1) strcat(outfilename1, "bin.num");
	else strcat(outfilename1, "nc.num");
	L=strlen(outfilename1);
	outfilename1[L]='\0';
	if ( (outfile1=fopen(outfilename1,"w") )==NULL) {
				fprintf(stderr, "can't open synonymous output file (.num)\n");
				exit(1);
				}
	}
/*create and open the output file ".num" for nonsynonymous distances*/
if(dist==2) {
	if(chname==1) {
		L=strlen(clearfilename);
		strncpy(outfilename2, clearfilename, L);
		}
	else {
		L=strlen(infilename);
		strncpy(outfilename2, infilename, L);
		}
	outfilename2[L]='\0';
	if(R==1) strcat(outfilename2, "bin.num");
	else strcat(outfilename2, "nc.num");
	L=strlen(outfilename2);
	outfilename2[L]='\0';	
	if ( (outfile2=fopen(outfilename2,"w") )==NULL) {
				fprintf(stderr, "can't open nonsynonymous output file (.num)\n");
				exit(1);
				}
	}


/*printf("Do you want to exclude some codons (Yes=1, No=2)?\n");
scanf("%d", &excl);*/
excl=2;
if(excl==1) {
	printf("What's the name of the file containing the excluded codons?\n");
	scanf("%s", excludefilename);

	/*open exclusion file*/
	if( (excludefile=fopen(excludefilename, "r"))==NULL) {
				printf("can't open exclusion file!\n");
				exit(1);
				}

	exclu=0;
	while( fscanf(excludefile, "%d", &exsite)!=EOF ) {
					if(exsite==0 || exsite>Nsites) {
								printf("ERROR: the codon %d does not exist!\n", exsite);
								exit(-1);
								}
					for(i=0; i<Nseq; i++) seq[i][exsite-1]='&';
					exclu++;
					}
	printf("\n%d sites (=%d codons) are excluded.\n", exclu, exclu/3);
	printf("Thus, the actual number of sites to be used is then %d\n\n", Nsites-exclu);

	jjj=0;
	indice=0;
	for(j=0; j<Nsites; j++) for(i=0; i<Nseq; i++) {
					if(seq[i][j]=='&') {
						if(j!=Nsites-1) for(i=0; i<Nseq; i++) for(jj=j; jj<Nsites-1; jj++) seq[i][jj]=seq[i][jj+1];
						indice+=1;
						Nsites-=1;
						j=j-1;
						break;
						}
					}
	for(i=0; i<Nseq; i++) seq[i][Nsites]='\0';

	/*create and open the excluded file*/
	L=strlen(infilename);
	strncpy(exoutfilename, infilename, L);
	exoutfilename[L]='\0';
	strcat(exoutfilename, "excluded");
	L=strlen(exoutfilename);
	exoutfilename[L]='\0';	
	if ( (exoutfile=fopen(exoutfilename,"w") )==NULL) {
					fprintf(stderr, "can't open excluded file\n");
					exit(1);
					}
	/*printf("Format of the exclusion file:\nnew phylip?  <1>\nold phylip?  <2>\n");
	scanf("%d", &phylip);*/
	phylip=1;
	if(phylip==1) {
		/*write all the sequences in new format*/
		fprintf(exoutfile, "%d  %d\n", Nseq, Nsites);
		i=l=0;
		while(i<Nsites) {
			for(j=0; j<Nseq; j++) {
				if(l==0) fprintf(exoutfile, "%s", seqname[j]);
				for(k=i; k<(i+50) && k<Nsites; k++) fprintf(exoutfile, "%c", seq[j][k]);
				fprintf(exoutfile, "\n");
				}
			fprintf(exoutfile, "\n");
			l++;
			i+=50;
			}
		}
	else {
		/*write all the sequences in old format*/
		fprintf(exoutfile, "%d  %d\n", Nseq, Nsites);
		for(i=0; i<Nseq; i++) {
			fprintf(exoutfile, "%s\n", seqname[i]);
			compt=0;
			for(j=0; j<Nsites; j++) {
				fprintf(exoutfile, "%c", seq[i][j]);
				compt++;
				if(compt==60) {
					fprintf(exoutfile, "\n");
					compt=0;
					}
				}
			fprintf(exoutfile, "\n");
			}
		}

	fclose(excludefile);
	fclose(exoutfile);	
	}


/*calculate the number of nonsynonymous sites per codon averaged for all sequences*/
Nm=0.0;
if(r==1 && ina==1) {
	asurbmoy=(double *)malloc(Nseq*sizeof(double));
	for(i=0;i<Nseq;i++) {
		asurbmoy[i]=0.0;
		for(j=0;j<Nseq;j++) {
			if(i!=j) {
				P=tot=0.0;
				for(k=0;k<Nsites;k++) {
					if(seq[i][k]!=seq[j][k]) {
							tot++;
							P+=transition(seq[i][k],seq[j][k]);
							}
					}
				if(R==2) {
					Q=(tot-P)/Nsites;
					P=P/Nsites;
					trsver=-0.125*log(1-2*Q);
					if(P==0.0) transi=0.0;
					else transi=-0.25*log(1-2*P-Q)+0.125*log(1-2*Q);
					/*printf("transi=%f, transver=%f,", transi, trsver);*/
					asurbmoy[i]+=(transi/trsver);
					}
				else {
					Q=(tot-P)/(Nsites*(1-t));
					P=P/(Nsites*(1-t));
					/*trsver=0.125*a*( pow((1-2*Q), -1.0/a) - 1 );*/
					JCtransversions=1;
					trsver=truncnegbinkimdist(P, Q);
					JCtransversions=2;
					if(P==0.0) transi=0.0;
					/*else transi=0.25*a*( pow((1-2*P-Q), -1.0/a) - 0.5*pow((1-2*Q), -1.0/a) - 0.5 );*/
					else {
						transi=truncnegbinkimdist(P, Q);
						transi=transi-trsver;
						}
					printf("transi=%f, transver=%f,", transi, trsver);
					/*asurbmoy[i]+=(transi/trsver);*/
					asurbmoy[i]+=2*(transi/trsver);
					}
				}
			}
		asurbmoy[i]/=(Nseq-1);
		printf("a/b=%f\n", asurbmoy[i]);
		}
	for(k=2; k<Nsites; k+=3) {
		for(i=0; i<Nseq; i++) Nm+=inasites(seq[i][k-2],seq[i][k-1],seq[i][k],asurbmoy[i],1);
		}
	free((char *)asurbmoy);
	}

else {
	for(k=2; k<Nsites; k+=3) {
		for(i=0; i<Nseq; i++) Nm+=numsites(seq[i][k-2],seq[i][k-1],seq[i][k]);
		}
	}


Nmoy=Nm/( Nseq*((double)Nsites/3) );
Sm=(Nseq*Nsites)-Nm;
Smoy=Sm/( Nseq*((double)Nsites/3) );
/*printf("Ntot=%f, Nmoy=%f, Stot=%f, Smoy=%f\n", Nm/Nseq, Nmoy, Sm/Nseq, Smoy);*/

/*calculate the mean per site, not per codon*/
/*if(R==1 && kind==1) {
		if(dist!=2) MOY/=Smoy;
		if(dist!=1) MOY/=Nmoy;
		printf("MOY/sites=%f\n", MOY);
		}*/


nterm=(double *)malloc( 2*sizeof(double) );

for(w=0,i=0;i<(Nseq-1);i++) {
		for(j=(i+1);j<Nseq;j++,w++) {
				if(r==1 && ina==1) {
					P=tot=0.0;
					for(k=0;k<Nsites;k++) {
				    /*compute the TOTAL number of transitional and transversional differences between the 2 sequences in order to compute the transition/transversion ratio, which is necessary for computing the number of nonsynonymous sites in the method of Ina*/
						if(seq[i][k]!=seq[j][k]) {
								tot++;
								P+=transition(seq[i][k],seq[j][k]);
								}
						}
					if(R==2) {
						Q=(tot-P)/Nsites;
						P=P/Nsites;
						trsver=-0.125*log(1-2*Q);
						if(P==0.0) transi=0.0;
						else transi=-0.25*log(1-2*P-Q)+0.125*log(1-2*Q);
						}
					else {
						Q=(tot-P)/(Nsites*(1-t));
						P=P/(Nsites*(1-t));
						/*trsver=0.125*a*( pow((1-2*Q), -1.0/a) - 1 );*/
						JCtransversions=1;
						trsver=truncnegbinkimdist(P, Q)/2;
						JCtransversions=2;
						if(P==0.0) transi=0.0;
						/*else transi=0.25*a*( pow((1-2*P-Q), -1.0/a) - 0.5*pow((1-2*Q), -1.0/a) - 0.5 );*/
						else {
							transi=truncnegbinkimdist(P, Q);
							transi=transi-2*trsver;
							}
						}
					}
				Nd=Ad=0.0;
				Sd=As=0.0;
				N1=N2=0.0;
				N=TotalSites=0.0;
				for(k=0; k<Nsites/3; k++) {
							nd[k]=0.0;
							ad[k]=0.0;
							bd[k]=0.0;
							sd[k]=0.0;
							as[k]=0.0;
							bs[k]=0.0;
							}
				for(v=0,k=2;k<Nsites;k+=3,v++) {
				   /*compute the numbers of nonsynonymous sites and differences*/
					index=0;
					for(l=k-2;l<=k;l++) if( seq[i][l]!=seq[j][l] ) index+=1;
					if(r==1 && ina==1) {
							n1=inasites(seq[i][k-2],seq[i][k-1],seq[i][k],transi,trsver);
							n2=inasites(seq[j][k-2],seq[j][k-1],seq[j][k],transi,trsver);
							n[v]=(n1+n2)/2;
							s[v]=3-n[v];
							N1+=n1;
							N2+=n2;
							}
					else {
						if(yang==2) {
							n1=numsites(seq[i][k-2],seq[i][k-1],seq[i][k]);
							n2=numsites(seq[j][k-2],seq[j][k-1],seq[j][k]);
							n[v]=(n1+n2)/2;
							s[v]=3-n[v];
							N1+=n1;
							N2+=n2;
							/*printf("n=%f, ", (n1+n2)/2);*/
							}

						else {
				nterm=yangsites(seq[i][k-2],seq[i][k-1],seq[i][k],seq[j][k-2],seq[j][k-1],seq[j][k]);
							n[v]=nterm[0];
							s[v]=nterm[1]-n[v];
							N+=nterm[0];
							TotalSites+=nterm[1];
							/*printf("n=%f,nb=%f ", nterm[0],nterm[1]);*/
							}
						}

					aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
					aa2=translate(seq[j][k-2],seq[j][k-1],seq[j][k]);

					mutant1=seq[j][k-2];
					mutant2=seq[j][k-1];
					mutant3=seq[j][k];

					if(index==1) {   /*codons differing only by one change*/
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[j][k-2],seq[j][k-1],seq[j][k]);
						if( aa1!=aa2 ) {
							Nd+=1;
							nd[v]+=1;
							if( seq[i][k-2]!=seq[j][k-2] ) {
									Ad+=transition(seq[i][k-2],seq[j][k-2]);
									ad[v]+=transition(seq[i][k-2],seq[j][k-2]);
									}
							else if(seq[i][k-1]!=seq[j][k-1]) {
									Ad+=transition(seq[i][k-1],seq[j][k-1]);
									ad[v]+=transition(seq[i][k-1],seq[j][k-1]);
									}
							else {
								Ad+=transition(seq[i][k],seq[j][k]);
								ad[v]+=transition(seq[i][k],seq[j][k]);
								}
							}
						else {
							Sd+=1;
							sd[v]+=1;
							if( seq[i][k-2]!=seq[j][k-2] ) {
									As+=transition(seq[i][k-2],seq[j][k-2]);
									as[v]+=transition(seq[i][k-2],seq[j][k-2]);
									}
							else if(seq[i][k-1]!=seq[j][k-1]) {
									As+=transition(seq[i][k-1],seq[j][k-1]);
									as[v]+=transition(seq[i][k-1],seq[j][k-1]);
									}
							else {
								As+=transition(seq[i][k],seq[j][k]);
								as[v]+=transition(seq[i][k],seq[j][k]);
								}
							}
						}

					if(index==2) {   /*codons differing by 2 changes*/
						x=y=ax=ay=0.0;
						xx=yy=axx=ayy=0.0;
						if( seq[i][k-2]==seq[j][k-2] ) { 
					   /*changes in positions 2 and 3 (positions 1 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k],mutant3);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k],mutant3);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k],mutant3);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k],mutant3);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-1],mutant2);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-1],mutant2);
								}

							if(stop==1) {
								Nd+=y;
								nd[v]+=y;
								Ad+=ay;
								ad[v]+=ay;
								Sd+=yy;
								sd[v]+=yy;
								As+=ayy;
								as[v]+=ayy;
								}
							else if(stop==10) {
								Nd+=x;
								nd[v]+=x;
								Ad+=ax;
								ad[v]+=ax;
								Sd+=xx;
								sd[v]+=xx;
								As+=axx;
								as[v]+=axx;
								}
							else if(stop==11) {
								Nd+=0.0;
								nd[v]+=0.0;
								Ad+=0.0;
								ad[v]+=0.0;
								Sd+=0.0;
								sd[v]+=0.0;
								As+=0.0;
								as[v]+=0.0;
								}
							else {
								Nd+=( (x+y)/2.0 );
								nd[v]+=( (x+y)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								ad[v]+=( (ax+ay)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								sd[v]+=( (xx+yy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								as[v]+=( (axx+ayy)/2.0 );
								}
							}

						else if( seq[i][k-1]==seq[j][k-1] ) { 
					   /*changes in positions 1 and 3 (positions 2 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-2],mutant1);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k],mutant3);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k],mutant3);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k],mutant3);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k],mutant3);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-2],mutant1);
								}

							if(stop==1) {
								Nd+=y;
								nd[v]+=y;
								Ad+=ay;
								ad[v]+=ay;
								Sd+=yy;
								sd[v]+=yy;
								As+=ayy;
								as[v]+=ayy;
								}
							else if(stop==10) {
								Nd+=x;
								nd[v]+=x;
								Ad+=ax;
								ad[v]+=ax;
								Sd+=xx;
								sd[v]+=xx;
								As+=axx;
								as[v]+=axx;
								}
							else if(stop==11) {
								Nd+=0.0;
								nd[v]+=0.0;
								Ad+=0.0;
								ad[v]+=0.0;
								Sd+=0.0;
								sd[v]+=0.0;
								As+=0.0;
								as[v]+=0.0;
								}
							else {
								Nd+=( (x+y)/2.0 );
								nd[v]+=( (x+y)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								ad[v]+=( (ax+ay)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								sd[v]+=( (xx+yy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								as[v]+=( (axx+ayy)/2.0 );
								}
							}

						else {
					   /*changes in positions 1 and 2 (positions 3 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-2],mutant1);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-1],mutant2);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-1],mutant2);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-2],mutant1);
								}

							if(stop==1) {
								Nd+=y;
								nd[v]+=y;
								Ad+=ay;
								ad[v]+=ay;
								Sd+=yy;
								sd[v]+=yy;
								As+=ayy;
								as[v]+=ayy;
								}
							else if(stop==10) {
								Nd+=x;
								nd[v]+=x;
								Ad+=ax;
								ad[v]+=ax;
								Sd+=xx;
								sd[v]+=xx;
								As+=axx;
								as[v]+=axx;
								}
							else if(stop==11) {
								Nd+=0.0;
								nd[v]+=0.0;
								Ad+=0.0;
								ad[v]+=0.0;
								Sd+=0.0;
								sd[v]+=0.0;
								As+=0.0;
								as[v]+=0.0;
								}
							else {
								Nd+=( (x+y)/2.0 );
								nd[v]+=( (x+y)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								ad[v]+=( (ax+ay)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								sd[v]+=( (xx+yy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								as[v]+=( (axx+ayy)/2.0 );
								}
							}

						}

					if(index==3) {  
			/*codons differing by 3 changes (6 pathways (x1,x2,y1,y2,z1,z2) and (xx1,xx2,yy1,yy2,zz1,zz2))*/
						x1=x2=y1=y2=z1=z2=ax1=ax2=ay1=ay2=az1=az2=0.0;
						xx1=xx2=yy1=yy2=zz1=zz2=axx1=axx2=ayy1=ayy2=azz1=azz2=0.0;
						stop=0;
						ind=6;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
						if( aa1!=aa2) {
							x1+=1;
							ax1+=transition(seq[i][k-2],mutant1);
							x2+=1;
							ax2+=transition(seq[i][k-2],mutant1);
							}
						else {
							xx1+=1;
							axx1+=transition(seq[i][k-2],mutant1);
							xx2+=1;
							axx2+=transition(seq[i][k-2],mutant1);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							x1=0;
							ax1=0;
							x2=0;
							ax2=0;
							xx1=0;
							axx1=0;
							xx2=0;
							axx2=0;
							ind-=2;
							}
						else {
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x1+=1;
								ax1+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx1+=1;
								axx1+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								x1+=1;
								ax1+=transition(seq[i][k],mutant3);
								}
							else {
								xx1+=1;
								axx1+=transition(seq[i][k],mutant3);
								}
							if(stop==10) {
									x1=0;
									ax1=0;
									xx1=0;
									axx1=0;
									ind-=1;
									}
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],mutant3);

							if( aa1!=aa2) {
								x2+=1;
								ax2+=transition(seq[i][k],mutant3);
								}
							else {
								xx2+=1;
								axx2+=transition(seq[i][k],mutant3);
								}
							if( aa2==21) stop+=20;
							aa1=translate(mutant1,seq[i][k-1],mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								x2+=1;
								ax2+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx2+=1;
								axx2+=transition(seq[i][k-1],mutant2);
								}
							if(stop==20 || stop==30) {
										x2=0;
										ax2=0;
										xx2=0;
										axx2=0;
										ind-=1;
										}
							}

						stop=0;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
						if( aa1!=aa2) {
							y1+=1;
							ay1+=transition(seq[i][k-1],mutant2);
							y2+=1;
							ay2+=transition(seq[i][k-1],mutant2);
							}
						else {
							yy1+=1;
							ayy1+=transition(seq[i][k-1],mutant2);
							yy2+=1;
							ayy2+=transition(seq[i][k-1],mutant2);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							y1=0;
							ay1=0;
							y2=0;
							ay2=0;
							yy1=0;
							ayy1=0;
							yy2=0;
							ayy2=0;
							ind-=2;
							}
						else {
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y1+=1;
								ay1+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy1+=1;
								ayy1+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								y1+=1;
								ay1+=transition(seq[i][k],mutant3);
								}
							else {
								yy1+=1;
								ayy1+=transition(seq[i][k],mutant3);
								}
							if(stop==10) {
									y1=0;
									ay1=0;
									yy1=0;
									ayy1=0;
									ind-=1;
									}

							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								y2+=1;
								ay2+=transition(seq[i][k],mutant3);
								}
							else {
								yy2+=1;
								ayy2+=transition(seq[i][k],mutant3);
								}
							if( aa2==21) stop+=20;
							aa1=translate(seq[i][k-2],mutant2,mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								y2+=1;
								ay2+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy2+=1;
								ayy2+=transition(seq[i][k-2],mutant1);
								}
							if(stop==20 || stop==30) {
										y2=0;
										ay2=0;
										yy2=0;
										ayy2=0;
										ind-=1;
										}
							}
						
						stop=0;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
						if( aa1!=aa2) {
							z1+=1;
							az1+=transition(seq[i][k],mutant3);
							z2+=1;
							az2+=transition(seq[i][k],mutant3);
							}
						else {
							zz1+=1;
							azz1+=transition(seq[i][k],mutant3);
							zz2+=1;
							azz2+=transition(seq[i][k],mutant3);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							z1=0;
							az1=0;
							z2=0;
							az2=0;
							zz1=0;
							azz1=0;
							zz2=0;
							azz2=0;
							ind-=2;
							}
						else {
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								z1+=1;
								az1+=transition(seq[i][k-2],mutant1);
								}
							else {
								zz1+=1;
								azz1+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,seq[i][k-1],mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								z1+=1;
								az1+=transition(seq[i][k-1],mutant2);
								}
							else {
								zz1+=1;
								azz1+=transition(seq[i][k-1],mutant2);
								}
							if(stop==10) {
									z1=0;
									az1=0;
									zz1=0;
									azz1=0;
									ind-=1;
									}
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(seq[i][k-2],mutant2,mutant3);

							if( aa1!=aa2) {
								z2+=1;
								az2+=transition(seq[i][k-1],mutant2);
								}
							else {
								zz2+=1;
								azz2+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21) stop+=20;
							aa1=translate(seq[i][k-2],mutant2,mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								z2+=1;
								az2+=transition(seq[i][k-2],mutant1);
								}
							else {
								zz2+=1;
								azz2+=transition(seq[i][k-2],mutant1);
								}
							if(stop==20 || stop==30) {
										z2=0;
										az2=0;
										zz2=0;
										azz2=0;
										ind-=1;
										}
							}
						if(ind!=0) {
							Nd+=( (x1+x2+y1+y2+z1+z2)/ind );
							nd[v]+=( (x1+x2+y1+y2+z1+z2)/ind );
							Ad+=( (ax1+ax2+ay1+ay2+az1+az2)/ind );
							ad[v]+=( (ax1+ax2+ay1+ay2+az1+az2)/ind );
							Sd+=( (xx1+xx2+yy1+yy2+zz1+zz2)/ind );
							sd[v]+=( (xx1+xx2+yy1+yy2+zz1+zz2)/ind );
							As+=( (axx1+axx2+ayy1+ayy2+azz1+azz2)/ind );
							as[v]+=( (axx1+axx2+ayy1+ayy2+azz1+azz2)/ind );
							}
						}
				}
				if(yang==2) {
					N=(N1+N2)/2;
					S=Nsites-N;
					}
				if(yang==1) S=TotalSites-N;
				/*printf("S=%f, N=%f, T=%f\n", S, N, TotalSites);*/
				Pn=Nd/N;
				Ps=Sd/S;
				/*printf("N=%f, S=%f, Nd=%f, Sd=%f\n", N, S, Nd, Sd);*/
				for(k=0; k<Nsites/3; k++) {
						bd[k]=nd[k]-ad[k];
						bs[k]=sd[k]-as[k];
						}
				switch(r) {
					case 2:
						if(R==2) {
							if(dist!=2) {
								/*printf("Ps=%f", Ps);*/
								ds[w]=-(3.0/4)*log( 1-((4.0/3)*Ps) );
								vars[w]=variancejc(Nsites, s, sd, S, Ps, 0, 0, R, invar);
								}
							if(dist!=1) {
								/*printf("Pn=%f", Pn);*/
								dn[w]=-(3.0/4)*log( 1-((4.0/3)*Pn) );
								varn[w]=variancejc(Nsites, n, nd, N, Pn, 0, 0, R, invar);
								}
							break;
							}
						else {
							if(invar==1) {
								Pn/=(1-t);
								Ps/=(1-t);
								N*=(1-t);
								S*=(1-t);
								}
							/*printf("Pn=%f Ps=%f", Pn, Ps);*/
							if(dist!=2) {
								if(kind==1) ds[w]=truncnegbinjcdist(Ps);
								else {
									/*printf("Ps=%f", Ps);*/
									ds[w]=(3.0/4)*a*( pow( (1-(4.0/3)*Ps),(-1.0/a) ) - 1 );
									vars[w]=variancejc(Nsites, s, sd, S, Ps, a, t, R, invar);
									}
								}
							if(dist!=1) {
								if(kind==1) dn[w]=truncnegbinjcdist(Pn);
								else {
									/*printf("Pn=%f", Pn);*/
									dn[w]=(3.0/4)*a*( pow( (1-(4.0/3)*Pn),(-1.0/a) ) - 1 );
									varn[w]=variancejc(Nsites, n, nd, N, Pn, a, t, R, invar);
									}
								}
							break;
							}
					default:
						if(R==2) {
							An=Ad/N;
							Bn=(Nd-Ad)/N;
							Cs=As/S;
							Ds=(Sd-As)/S;
							
							if(dist!=2) {
								/*if(Cs==0.0 && Ds!=0.0) printf("p==0 et q!=0,");*/
								trsver=-0.125*log(1-2*Ds);
								transi=-0.25*log(1-2*Cs-Ds)+0.125*log(1-2*Ds);
								/*printf("Cs=%f Ds=%f Ps=%f a/b=%f\n", Cs, Ds, Sd/S, transi/trsver);*/
								if(JCtransversions==1) {
										ds[w]=-(1.0/2.0)*log( 1-2*Ds );
										/*if(Cs!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*Cs-Ds )+(1.0/4.0)*log( 1-2*Ds ));*/
										}
								else {
									if(Cs==0.0) ds[w]=-(1.0/2.0)*log( 1-2*Ds );
									else ds[w]=-(1.0/2.0)*log( (1-2*Cs-Ds)*sqrt(1-2*Ds) );
									vars[w]=variancekim(Nsites, s, as, bs, S, Cs, Ds, 0, 0, R, invar);
									} 
								}
							if(dist!=1) {
								/*if(An==0.0 && Bn!=0.0) printf("p==0 et q!=0,");*/
								trsver=-0.125*log(1-2*Bn);
								transi=-0.25*log(1-2*An-Bn)+0.125*log(1-2*Bn);
								/*printf("An=%f Bn=%f Pn=%f a/b=%f\n", An, Bn, Nd/N, transi/trsver);*/
								if(JCtransversions==1) {
										dn[w]=-(1.0/2.0)*log( 1-2*Bn );
										/*if(An!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*An-Bn )+(1.0/4.0)*log( 1-2*Bn ));*/
										}
								else {
									if(An==0.0) dn[w]=-(1.0/2.0)*log( 1-2*Bn );
									else dn[w]=-(1.0/2.0)*log( (1-2*An-Bn)*sqrt(1-2*Bn) );
									varn[w]=variancekim(Nsites, n, ad, bd, N, An, Bn, 0, 0, R, invar);
									} 
								}
							break;
							}
						else {
							if(invar==1) {
								N*=(1-t);
								S*=(1-t);
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								Cs=As/S;
								Ds=(Sd-As)/S;
								}
							else {
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								Cs=As/S;
								Ds=(Sd-As)/S;
								}

							if(dist!=2) {
								/*if(Cs==0.0 && Ds!=0.0) printf("p==0 et q!=0,");*/
								if(kind==1) {
									/*printf("Cs=%f Ds=%f Ps=%f a/b=%f\n", Cs, Ds, Sd/(S*(1-t)), transi/trsver);*/
									ds[w]=truncnegbinkimdist(Cs, Ds);
									}
								else {
									trsver=0.125*a*( pow((1-2*Ds), -1.0/a) - 1 );
									transi=0.25*a*( pow((1-2*Cs-Ds), -1.0/a) - 0.5*pow((1-2*Ds), -1.0/a) - 0.5 );
									/*printf("Cs=%f Ds=%f Ps=%f a/b=%f\n", Cs, Ds, Sd/(S*(1-t)), transi/trsver);*/
									ds[w]=(a/2.0)*( pow( (1-2*Cs-Ds),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Ds),(-1.0/a) ) - 1.5 );
									vars[w]=variancekim(Nsites, s, as, bs, S, Cs, Ds, a, t, R, invar);
									}
								}
							if(dist!=1) {
								/*if(An==0.0 && Bn!=0.0) printf("p==0 et q!=0,");*/
								if(kind==1) {
									/*printf("An=%f Bn=%f Pn=%f a/b=%f\n", An, Bn, Nd/(N*(1-t)), transi/trsver);*/
									dn[w]=truncnegbinkimdist(An, Bn);
									}
								else {
									trsver=0.125*a*( pow((1-2*Bn), -1.0/a) - 1 );
									transi=0.25*a*( pow((1-2*An-Bn), -1.0/a) - 0.5*pow((1-2*Bn), -1.0/a) - 0.5 );
									/*printf("An=%f Bn=%f Pn=%f a/b=%f\n", An, Bn, Nd/(N*(1-t)), transi/trsver);*/
									dn[w]=(a/2.0)*( pow( (1-2*An-Bn),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Bn),(-1.0/a) ) - 1.5 );
									varn[w]=variancekim(Nsites, n, ad, bd, N, An, Bn, a, t, R, invar);
									}
								}
							break;
							}						
					}
				}
		}


/*printf("Do you want to compute the variances of the distances? (Yes=1, No=2)\n");
scanf("%d", &printvar);*/
printvar=2;
if(dist!=2) {
	printnum(outfile1, Nseq, seqname, ds, r, ina, R);
	if(printvar==1) if(R==2 || (R==1 && kind!=1)) {
					fprintf(outfile1, "Variances:\n");
					printnum(outfile1, Nseq, seqname, vars, r, ina, R);
					}
	}
if(dist!=1) {
	printnum(outfile2, Nseq, seqname, dn, r, ina, R);
	if(printvar==1) if(R==2 || (R==1 && kind!=1)) {
					fprintf(outfile2, "Variances:\n");
					printnum(outfile2, Nseq, seqname, varn, r, ina, R);
					}
	}

printf("(%d comparisons)\n", w);


for(i=0; i<Nseq; i++) {
			free(seqname[i]);
			free(seq[i]);
			}
			      
fclose(infile);
if(dist!=2) fclose(outfile1);
if(dist!=1) fclose(outfile2);

return 0;
}


/*function which computes the variance of the distance for one pair of sequences only using the Jukes/Cantor's formula*/
double variancejc(int Nsites, double *n, double *nd, double N, double Pn, double a, double t, int R, int invar)
{
int i;
double vpn=0.0, var, inter1, inter2;

for(i=0; i<Nsites/3; i++) {
		if(R==1 && invar==1) inter1=nd[i]-( Pn*n[i]*(1-t) );
		else inter1=nd[i]-(Pn*n[i]);
		vpn+=(inter1*inter1);
		}
vpn/=(N*N);

if(R==1) {
	inter2=pow( 1-(4.0/3)*Pn, -2.0*((a+1)/a) );
	var=inter2*vpn;
	}
else {
	inter2=1-(4.0/3)*Pn;
	var=vpn/(inter2*inter2);
	}

return var;
} 

/*function which computes the variance of the distance for one pair of sequences only using the Kimura's formula*/
/*(This function computes the variance of transitions, the variance of transversions and the covariance between them)*/
double variancekim(int Nsites, double *n, double *ad, double *bd, double N, double An, double Bn, double a, double t, int R, int invar)
{
int i;
double van=0.0, vbn=0.0, covab=0.0, var, intera, interb, c1, c2;

for(i=0; i<Nsites/3; i++) {
		if(R==1 && invar==1) {
				intera=ad[i]-( An*n[i]*(1-t) );
				interb=bd[i]-( Bn*n[i]*(1-t) );
				}
		else {
			intera=ad[i]-(An*n[i]);
			interb=bd[i]-(Bn*n[i]);
			}
		van+=(intera*intera);
		vbn+=(interb*interb);
		covab+=(intera*interb);
		}
van/=(N*N);
vbn/=(N*N);
covab/=(N*N);


if(R==1) {
	c1=pow( (1-2*An-Bn), -(a+1)/a );
	c2=(1.0/2.0)*( pow( (1-2*An-Bn), -(a+1)/a ) + pow( (1-2*Bn), -(a+1)/a ) );
	var=(c1*c1)*van + (c2*c2)*vbn + 2*c1*c2*covab;
	}
else {
	c1=1.0/(1-2*An-Bn);
	c2=(1.0/2.0)*( 1.0/(1-2*An-Bn) + 1.0/(1-2*Bn) );
	var=(c1*c1)*van + (c2*c2)*vbn + 2*c1*c2*covab;
	}

return var;
} 


/*function which translates the codons into amino acids using the genetic code*/
int translate(char c1, char c2, char c3)
{
int aa;
enum aminoacid { ala=1, arg, asn, asp, cys, gln, glu, gly, his, ileu, leu, lys, met, phe, pro, ser, thr, trp, tyr, val, stop};   /*here, we have not to distinguish between the two types of serine codons (ser1 and ser2) because they differ by more than one change*/

     	     if( c1=='A' && c2=='A' && (c3=='A'||c3=='G') ) aa=lys ;
	else if( c1=='A' && c2=='A' && (c3=='C'||c3=='T') ) aa=asn ;
	else if( c1=='A' && c2=='C' )                       aa=thr ;
	else if( c1=='A' && c2=='G' && (c3=='A'||c3=='G') ) aa=arg ;
	else if( c1=='A' && c2=='G' && (c3=='C'||c3=='T') ) aa=ser ;
	else if( c1=='A' && c2=='T' && c3!='G' )            aa=ileu;
	else if( c1=='A' && c2=='T' && c3=='G' )            aa=met ;
	else if( c1=='C' && c2=='A' && (c3=='A'||c3=='G') ) aa=gln ;
	else if( c1=='C' && c2=='A' && (c3=='C'||c3=='T') ) aa=his ;
	else if( c1=='C' && c2=='C' )                       aa=pro ;
	else if( c1=='C' && c2=='G' )                       aa=arg ;
	else if( c1=='C' && c2=='T' )                       aa=leu ;
	else if( c1=='G' && c2=='A' && (c3=='A'||c3=='G') ) aa=glu ;
	else if( c1=='G' && c2=='A' && (c3=='C'||c3=='T') ) aa=asp ;
	else if( c1=='G' && c2=='C' )                       aa=ala ;
	else if( c1=='G' && c2=='G' )                       aa=gly ;
	else if( c1=='G' && c2=='T' )                       aa=val ;
	else if( c1=='T' && c2=='A' && (c3=='A'||c3=='G') ) aa=stop;
	else if( c1=='T' && c2=='A' && (c3=='C'||c3=='T') ) aa=tyr ;
	else if( c1=='T' && c2=='C' )                       aa=ser ;
	else if( c1=='T' && c2=='G' && c3=='A' )            aa=stop;
	else if( c1=='T' && c2=='G' && (c3=='C'||c3=='T') ) aa=cys ;
	else if( c1=='T' && c2=='G' && c3=='G' )            aa=trp ;
	else if( c1=='T' && c2=='T' && (c3=='A'||c3=='G') ) aa=leu ;
	else if( c1=='T' && c2=='T' && (c3=='C'||c3=='T') ) aa=phe ;
		else {printf("UNKNOWN CODON\n");exit(-34);}

return aa;
}

 
/*function which calculates the number of nonsynonymous sites for one codon only (in fact, this corresponds to the table of Perler)*/
double numsites(char c1, char c2, char c3)
{
int aa;
double N;

aa=translate(c1, c2, c3);

     if(aa==1 || aa==8 || aa==15 || aa==17 || aa==20) N=6;
else if(aa==3 || aa==4 || aa==5 || aa==6 || aa==7 || aa==9 || aa==12 || aa==14 || aa==19) N=8;
else if(aa==13 || aa==18) N=9;
else if(aa==10) N=7;
else if(aa==2) {
	if( c1=='C' && c2=='G' && (c3=='C' || c3=='T') ) N=6;
	else if( c1=='C' && c2=='G' && (c3=='A' || c3=='G') ) N=5;
	else N=7;
	}
else if(aa==11) {
	if( c1=='C' && c2=='T' && (c3=='C' || c3=='T') ) N=6;
	else if( c1=='C' && c2=='T' && (c3=='A' || c3=='G') ) N=5;
	else N=7;
	}
else if(aa==16) {
	if( c1=='A' && c2=='G' ) N=8;
	else N=6;
	}
else {
	if(aa!=21) {
		printf("ERROR: UNTRANSLATABLE CODON %c%c%c IN FUNCTION <NUMSITES>!\n", c1,c2,c3);
		exit(-1);
		}
	}

return N/3;
}

/*function which calculates the number of synonymous sites for one codon only and searches for stop codons
(in fact, this corresponds to taking into account the stop codons in the table of Perler)*/
int *termsites(char c1, char c2, char c3)
{
int *N;

N=(int *)malloc( 2*sizeof(int) );

     	     if( c1=='A' && c2=='A' && (c3=='A'||c3=='G') ) {N[0]=1;N[1]=1;}
	else if( c1=='A' && c2=='A' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=0;}
	else if( c1=='A' && c2=='C' )                       {N[0]=3;N[1]=0;}
	else if( c1=='A' && c2=='G' && c3=='A' )            {N[0]=2;N[1]=1;}
	else if( c1=='A' && c2=='G' && c3=='G' )            {N[0]=2;N[1]=0;}
	else if( c1=='A' && c2=='G' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=0;}
	else if( c1=='A' && c2=='T' && c3!='G' )            {N[0]=2;N[1]=0;}
	else if( c1=='A' && c2=='T' && c3=='G' )            {N[0]=0;N[1]=0;}
	else if( c1=='C' && c2=='A' && (c3=='A'||c3=='G') ) {N[0]=1;N[1]=1;}
	else if( c1=='C' && c2=='A' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=0;}
	else if( c1=='C' && c2=='C' )                       {N[0]=3;N[1]=0;}
	else if( c1=='C' && c2=='G' && (c3=='C'||c3=='T') ) {N[0]=3;N[1]=0;}
	else if( c1=='C' && c2=='G' && c3=='G' )            {N[0]=4;N[1]=0;}
	else if( c1=='C' && c2=='G' && c3=='A' )            {N[0]=4;N[1]=1;}
	else if( c1=='C' && c2=='T' && (c3=='A'||c3=='G') ) {N[0]=4;N[1]=0;}
	else if( c1=='C' && c2=='T' && (c3=='C'||c3=='T') ) {N[0]=3;N[1]=0;}
	else if( c1=='G' && c2=='A' && (c3=='A'||c3=='G') ) {N[0]=1;N[1]=1;}
	else if( c1=='G' && c2=='A' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=0;}
	else if( c1=='G' && c2=='C' )                       {N[0]=3;N[1]=0;}
	else if( c1=='G' && c2=='G' && c3!='A' )            {N[0]=3;N[1]=0;}
	else if( c1=='G' && c2=='G' && c3=='A' )            {N[0]=3;N[1]=1;}
	else if( c1=='G' && c2=='T' )                       {N[0]=3;N[1]=0;}
	else if( c1=='T' && c2=='A' && (c3=='A'||c3=='G') ) {printf("STOP CODON\n");exit(-34);}
	else if( c1=='T' && c2=='A' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=2;}
	else if( c1=='T' && c2=='C' && c3=='A' )            {N[0]=3;N[1]=2;}
	else if( c1=='T' && c2=='C' && c3=='G' )            {N[0]=3;N[1]=1;}
	else if( c1=='T' && c2=='C' && (c3=='C'||c3=='T') ) {N[0]=3;N[1]=0;}
	else if( c1=='T' && c2=='G' && c3=='A' )            {printf("STOP CODON\n");exit(-34);}
	else if( c1=='T' && c2=='G' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=1;}
	else if( c1=='T' && c2=='G' && c3=='G' )            {N[0]=0;N[1]=2;}
	else if( c1=='T' && c2=='T' && c3=='A' )            {N[0]=2;N[1]=2;}
	else if( c1=='T' && c2=='T' && c3=='G' )            {N[0]=2;N[1]=1;}
	else if( c1=='T' && c2=='T' && (c3=='C'||c3=='T') ) {N[0]=1;N[1]=0;}
		else {printf("UNKNOWN CODON\n");exit(-34);}

return N;
}

/*function which calculates the number of nonsynonymous sites for a pair of sequences and for one codon only using the method of Yang*/
double *yangsites(char c1, char c2, char c3, char k1, char k2, char k3)
{
int *N1, *N2;
double *S, SynSites, TotalSites, nstop;

N1=(int *)malloc( 2*sizeof(int) );N2=(int *)malloc( 2*sizeof(int) );
S=(double *)malloc( 2*sizeof(double) );

N1=termsites(c1, c2, c3);
N2=termsites(k1, k2, k3);

SynSites=N1[0]+N2[0];
nstop=N1[1]+N2[1];
TotalSites=3*(1-nstop/18); /*total number of sites for the codon averaged for the pair of sequences. TotalSites!=3 if stop codons*/

S[0]=TotalSites - SynSites*3.0/( 18-nstop ); /*number of nonsynonymous sites for the codon averaged for the pair of sequences*/
S[1]=TotalSites;

return S;
}


/*function which calculates the number of nonsynonymous sites for one codon only using the method of Ina
(in fact, this corresponds to taking into account transitions and transversions in the table of Perler)*/
double inasites(char c1, char c2, char c3, double a, double b)
{
int aa;
double N;

aa=translate(c1, c2, c3);

     if(aa==1 || aa==8 || aa==15 || aa==17 || aa==20) N=2*a+4*b;
else if(aa==3 || aa==4 || aa==5 || aa==6 || aa==7 || aa==9 || aa==12 || aa==14 || aa==19) N=2*a+6*b;
else if(aa==13 || aa==18) N=3*a+6*b;
else if(aa==10) {
	if(c3=='A') N=3*a+4*b;
	else N=2*a+5*b;
	}
else if(aa==2) {
	if( c1=='C' && (c3=='C' || c3=='T') ) N=2*a+4*b;
	else if( c1=='C' && (c3=='A' || c3=='G') ) N=2*a+3*b;
	else N=2*a+5*b;
	}
else if(aa==11) {
	if( c1=='C' && (c3=='C' || c3=='T') ) N=2*a+4*b;
	else if( c1=='C' && (c3=='A' || c3=='G') ) N=a+4*b;
	else N=a+6*b;
	}
else if(aa==16) {
	if( c1=='A' && c2=='G' ) N=2*a+6*b;
	else N=2*a+4*b;
	}
else printf("stop");

return N/(a+2*b);
}


/*function which calculates the number of transitional changes*/
double transition(char c1, char c2)
{
double x;

if( (c1=='A' && c2=='G') || (c1=='G' && c2=='A') || (c1=='C' && c2=='T') || (c1=='T' && c2=='C') ) x=1.0;
else x=0.0;

return x; 
}


/*function which reads one sequence only in old phylip format*/
char *lireseq(FILE *infile, int Nsites)
{
char *seq;
int i;
int c;
long int pos;

/*allocate memory for the pointer sequence*/
if( (seq=(char*)malloc((Nsites+1)*sizeof(char)) )==NULL) {
				printf("not enough memory\n");
				exit(1);
				}

/*read the sequence*/
i=0;
while(i<Nsites)	{
		c=fgetc(infile);
		if(c=='\n' || c==' ') continue;
		if(islower(c)!=0) c=toupper(c);
		if(c=='U') c='T';
		seq[i]=c;
		i++;
		}

/*put \0 at the end of the sequence*/
seq[i]='\0';

while( (c=fgetc(infile))=='\n' || c==' ' ) ;
pos=ftell(infile);
fseek(infile, pos-1L, 0);

return seq;
}


/*function which reads the name of one sequence only in old phylip format*/
char *lirenom(FILE *infile)
{
char *nom;
int i, c;

/*allocate memory for the pointer nom */
if( (nom=(char*)malloc( (nmlngth+1)*sizeof(char)) )==NULL) {
				printf("not enough memory\n");
				exit(1);
				}

/*read the name of the sequence*/
for(i=0; (c=fgetc(infile))!='\n'; i++) {
				nom[i]=c;
				}
nom[i]='\0';

return nom;
}

/*function which reads the name of one sequence only in new phylip format*/
char *newname(FILE *infile)
{
char *nom;
int i, c;

/*allocate memory for the pointer nom */
if( (nom=(char*)malloc( (nmlngth+1)*sizeof(char)) )==NULL ) {
				printf("not enough memory\n");
				exit(1);
				}

/*read the name of the sequence*/
i=0;
while(i<nmlngth) {
	c=fgetc(infile);
	if(c=='\n') continue;
	nom[i]=c;
	i++;
	}
nom[i]='\0';

return nom;
}

/*function which reads all the sequences in new phylip format*/
void newseq(FILE *infile, int Nseq, int Nsites, char **seq, char **seqname)
{
int i, j, k, x;
int c;

/*allocate memory for all the pointers seq[i] */
for(i=0; i<Nseq; i++) {
			seq[i]=(char *)malloc((Nsites+1)*sizeof(char));
			if(seq[i]==NULL) {
					printf("not enough memory\n");
					exit(1);
					}
			}

/*read all the sequences in new format*/
i=j=x=0;
while(i<Nseq) {
		if(x==0) seqname[i]=newname(infile);
		k=0;
		while( (c=fgetc(infile))!='\n' ) {
					if(c==' ') continue;
					if(islower(c)!=0) c=toupper(c);
					if(c=='U') c='T';
					seq[i][j]=c;
					k++;
					j++;
					}
		if(k==0) continue;
		if(i<(Nseq-1)) j=j-k;
		if(i==(Nseq-1)) {
			if(j!=Nsites) i=(-1);
			x++;
			}
		i++;
		}

/*put \0 at the end of all the sequences*/
for(i=0; i<Nseq; i++) seq[i][j]='\0';
}


/*function which writes the distances and variances in the ".num" outfile*/
void printnum(FILE *outfile, int Nseq, char *seqname[], double *tab, int r, int ina, int R)
{
int i, j, jj, w;

fprintf(outfile, "  %d\n", Nseq);

for(w=0,i=0;i<(Nseq-1);i++) {
		jj=1;
		for(j=(i+1);j<Nseq;j++,w++) {
				if(tab[w]==-15000.0) fprintf(outfile, "   NaN");
				else fprintf(outfile, "   %f", tab[w]);
				if(jj==7 && j!=(Nseq-1)) {
					fprintf(outfile, "\n");
					jj=0;
					}
				jj++;
				}
		fprintf(outfile, "\n");
		}
fprintf(outfile, "\n");

/*write the names of the sequences below the matrix to complete the ".num" format*/
if(ina==1) {
	if(R==1) {
		if(kind==3) fprintf(outfile, "Option: Ina(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
		if(kind==2) fprintf(outfile, "Option: Ina(continuous gamma) with a=%.3f\n", a);
		if(kind==1) fprintf(outfile, "Option: Ina(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
		}
	else fprintf(outfile, "Option: Ina\n");
	}
else {
	if(r==1 && R==1) {
			if(kind==3) fprintf(outfile, "Option: NGkim(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
			if(kind==2) fprintf(outfile, "Option: NGkim(continuous gamma) with a=%.3f\n", a);
			if(kind==1) {
				if(JCtransversions==1) fprintf(outfile, "Option: NGkim-transversions(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
				else fprintf(outfile, "Option: NGkim(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
				}
			}
	else if(r==1 && R==2) {
			if(JCtransversions==1) fprintf(outfile, "Option: NGkim-transversions\n");
			else fprintf(outfile, "Option: NGkim\n");
			}
	else if(r==2 && R==1) {
			if(kind==3) fprintf(outfile, "Option: NGjc(inv + continuous gamma) with a=%.3f, t=%.3f\n", a, t);
			if(kind==2) fprintf(outfile, "Option: NGjc(continuous gamma) with a=%.3f\n", a);
			if(kind==1) fprintf(outfile, "Option: NGjc(negative binomial) with a=%.3f, b=%.3f, t=%.3f, moy=%.3f\n", a, b, t, MOY);
			}
	else fprintf(outfile, "Option: NGjc\n");
	}
j=1;
for(i=0; i<Nseq; i++) {			
			fprintf(outfile, "%-20.20s", seqname[i]);
			if(j==4) {
				fprintf(outfile, "\n");
				j=0;
				}
			j++;
			}
fprintf(outfile, "\n\n");

}

/*function which calculates the Jukes-and-Cantor-like distance of Tourasse
and Gouy (modification of the Jukes-and-Cantor's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/ 
double truncnegbinjcdist(double p)
{
double d, V, Z, temp1, temp2, temp3, temp4;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-(4.0/3)*p;
Z=temp1*temp2;


temp3=pow(Z+1,(-1.0/a));
temp4=((1+b)/b)*(1-temp3);

d=-(3.0/4)*MOY*log(temp4);

return d;
}

/*function which calculates the Kimura-like distance of Tourasse
and Gouy (modification of the Kimura's distance for nucleic sequences
using an Invariant+Truncated Negative Binomial distribution)*/ 
double truncnegbinkimdist(double p, double q)
{
double d1, d2, V, Z1, Z2, temp1, temp2, temp3, temp4, temp5, temp6, temp7;

V=pow( 1.0/(1+b),a );
temp1=(1-V)/V;

temp2=1-2*q;
Z1=temp1*temp2;
temp3=1-2*p-q;
Z2=temp1*temp3;

temp4=pow(Z1+1,(-1.0/a));
temp5=pow(Z2+1,(-1.0/a));
temp6=((1+b)/b)*(1-temp4);
temp7=((1+b)/b)*(1-temp5);

d1=-(1.0/4)*MOY*log(temp6);
d2=-(1.0/2)*MOY*log(temp7);
if(q==0.0) d1=0.0;
if(p==0.0) d2=d1;
/*printf("d1=%f, d2=%f\n", 2*d1, d2-d1);*/

if(JCtransversions==1) return 2*d1;
else return d1+d2;
}
