#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 1000

/*prototypes*/
int translate(char, char, char);
double numsites(char, char, char);
double transition(char, char);
/*double discrdis(double p, int indice, FILE *infile);
double jinneidis(double p, double q, FILE *infile);*/
double truncnegbinjcdist(double p);
double truncnegbinkimdist(double p, double q);

extern double a, b, MOY;
extern int transiversions;


int preneigojodist(int Nseq, int Nsites, char **seq, double **ka, double **n, double **nd, double **ad, double **sd, double **as, int R, int r, int invar, int dist, int distrib, double t)
{
int i, j, k, l, v, w, index, ind, aa1, aa2, stop;
char mutant1, mutant2, mutant3;
double x, y, x1, x2, y1, y2, z1, z2, ax, ay, ax1, ax2, ay1, ay2, az1, az2;
double xx, yy, xx1, xx2, yy1, yy2, zz1, zz2, axx, ayy, axx1, axx2, ayy1, ayy2, azz1, azz2;
double Nd, Ad, Pn, An, Bn, N, N1, N2;
double Sd, As, Ps, Cs, Ds, S;
double Nm, Sm, Nmoy, Smoy;
int sat;

/*calculate the number of nonsynonymous sites per codon averaged for all sequences*/
Nm=0.0;
for(k=2; k<Nsites; k+=3) for(i=0; i<Nseq; i++) Nm+=numsites(seq[i][k-2],seq[i][k-1],seq[i][k]);

Nmoy=Nm/( Nseq*((double)Nsites/3) );
Sm=(Nseq*Nsites)-Nm;
Smoy=Sm/( Nseq*((double)Nsites/3) );

/*calculate the mean per site, not per codon*/
/*if(R==1 && distrib==2) {
		if(dist==1) MOY/=Smoy;
		if(dist==2) MOY/=Nmoy;
		printf("MOY/sites=%f\n", MOY);
		}*/

sat=0;
for(w=0,i=0;i<(Nseq-1);i++) {
		for(j=(i+1);j<Nseq;j++,w++) {
				Nd=Ad=0.0;
				Sd=As=0.0;
				N1=N2=0.0;
				for(v=0,k=2;k<Nsites;k+=3,v++) {
					index=0;
					for(l=k-2;l<=k;l++) if( seq[i][l]!=seq[j][l] ) index+=1;
					n[i][v]=numsites(seq[i][k-2],seq[i][k-1],seq[i][k]);
					n[j][v]=numsites(seq[j][k-2],seq[j][k-1],seq[j][k]);
					N1+=n[i][v];
					N2+=n[j][v];

					mutant1=seq[j][k-2];
					mutant2=seq[j][k-1];
					mutant3=seq[j][k];

					if(index==1) {   /*codons differing only by one change*/
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[j][k-2],seq[j][k-1],seq[j][k]);
						if( aa1!=aa2 ) {
							nd[w][v]+=1;
							Nd+=1;
							if( seq[i][k-2]!=seq[j][k-2] ) {
									Ad+=transition(seq[i][k-2],seq[j][k-2]);
									ad[w][v]+=transition(seq[i][k-2],seq[j][k-2]);
									}
							else if(seq[i][k-1]!=seq[j][k-1]) {
									Ad+=transition(seq[i][k-1],seq[j][k-1]);
									ad[w][v]+=transition(seq[i][k-1],seq[j][k-1]);
									}
							else {
								Ad+=transition(seq[i][k],seq[j][k]);
								ad[w][v]+=transition(seq[i][k],seq[j][k]);
								}
							}
						else {
							sd[w][v]+=1;
							Sd+=1;
							if( seq[i][k-2]!=seq[j][k-2] ) {
									As+=transition(seq[i][k-2],seq[j][k-2]);
									as[w][v]+=transition(seq[i][k-2],seq[j][k-2]);
									}
							else if(seq[i][k-1]!=seq[j][k-1]) {
									As+=transition(seq[i][k-1],seq[j][k-1]);
									as[w][v]+=transition(seq[i][k-1],seq[j][k-1]);
									}
							else {
								As+=transition(seq[i][k],seq[j][k]);
								as[w][v]+=transition(seq[i][k],seq[j][k]);
								}
							}
						}

					if(index==2) {   /*codons differing by 2 changes*/
						x=y=ax=ay=0.0;
						xx=yy=axx=ayy=0.0;
						if( seq[i][k-2]==seq[j][k-2] ) { 
					   /*changes in positions 2 and 3 (positions 1 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k],mutant3);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k],mutant3);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k],mutant3);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k],mutant3);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-1],mutant2);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-1],mutant2);
								}

							if(stop==1) {
								nd[w][v]+=y;
								Nd+=y;
								ad[w][v]+=ay;
								Ad+=ay;
								sd[w][v]+=yy;
								Sd+=yy;
								as[w][v]+=ayy;
								As+=ayy;
								}
							else if(stop==10) {
								nd[w][v]+=x;
								Nd+=x;
								ad[w][v]+=ax;
								Ad+=ax;
								sd[w][v]+=xx;
								Sd+=xx;
								as[w][v]+=axx;
								As+=axx;
								}
							else if(stop==11) {
								nd[w][v]+=0;
								Nd+=0;
								ad[w][v]+=0;
								Ad+=0;
								sd[w][v]+=0;
								Sd+=0;
								as[w][v]+=0;
								As+=0;
								}
							else {
								nd[w][v]+=( (x+y)/2.0 );
								Nd+=( (x+y)/2.0 );
								ad[w][v]+=( (ax+ay)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								sd[w][v]+=( (xx+yy)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								as[w][v]+=( (axx+ayy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								}
							}

						else if( seq[i][k-1]==seq[j][k-1] ) { 
					   /*changes in positions 1 and 3 (positions 2 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-2],mutant1);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k],mutant3);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k],mutant3);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k],mutant3);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k],mutant3);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-2],mutant1);
								}

							if(stop==1) {
								nd[w][v]+=y;
								Nd+=y;
								ad[w][v]+=ay;
								Ad+=ay;
								sd[w][v]+=yy;
								Sd+=yy;
								as[w][v]+=ayy;
								As+=ayy;
								}
							else if(stop==10) {
								nd[w][v]+=x;
								Nd+=x;
								ad[w][v]+=ax;
								Ad+=ax;
								sd[w][v]+=xx;
								Sd+=xx;
								as[w][v]+=axx;
								As+=axx;
								}
							else if(stop==11) {
								nd[w][v]+=0;
								Nd+=0;
								ad[w][v]+=0;
								Ad+=0;
								sd[w][v]+=0;
								Sd+=0;
								as[w][v]+=0;
								As+=0;
								}
							else {
								nd[w][v]+=( (x+y)/2.0 );
								Nd+=( (x+y)/2.0 );
								ad[w][v]+=( (ax+ay)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								sd[w][v]+=( (xx+yy)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								as[w][v]+=( (axx+ayy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								}
							}

						else {
					   /*changes in positions 1 and 2 (positions 3 identical)*/
							stop=0;
							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-2],mutant1);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21 ) stop+=1;
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x+=1;
								ax+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx+=1;
								axx+=transition(seq[i][k-1],mutant2);
								}

							aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-1],mutant2);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21 ) stop+=10;
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y+=1;
								ay+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy+=1;
								ayy+=transition(seq[i][k-2],mutant1);
								}

							if(stop==1) {
								nd[w][v]+=y;
								Nd+=y;
								ad[w][v]+=ay;
								Ad+=ay;
								sd[w][v]+=yy;
								Sd+=yy;
								as[w][v]+=ayy;
								As+=ayy;
								}
							else if(stop==10) {
								nd[w][v]+=x;
								Nd+=x;
								ad[w][v]+=ax;
								Ad+=ax;
								sd[w][v]+=xx;
								Sd+=xx;
								as[w][v]+=axx;
								As+=axx;
								}
							else if(stop==11) {
								nd[w][v]+=0;
								Nd+=0;
								ad[w][v]+=0;
								Ad+=0;
								sd[w][v]+=0;
								Sd+=0;
								as[w][v]+=0;
								As+=0;
								}
							else {
								nd[w][v]+=( (x+y)/2.0 );
								Nd+=( (x+y)/2.0 );
								ad[w][v]+=( (ax+ay)/2.0 );
								Ad+=( (ax+ay)/2.0 );
								sd[w][v]+=( (xx+yy)/2.0 );
								Sd+=( (xx+yy)/2.0 );
								as[w][v]+=( (axx+ayy)/2.0 );
								As+=( (axx+ayy)/2.0 );
								}
							}

						}

					if(index==3) {  
				/*codons differing by 3 changes (6 pathways (x1,x2,y1,y2,z1,z2) and (xx1,xx2,yy1,yy2,zz1,zz2))*/
						x1=x2=y1=y2=z1=z2=ax1=ax2=ay1=ay2=az1=az2=0.0;
						xx1=xx2=yy1=yy2=zz1=zz2=axx1=axx2=ayy1=ayy2=azz1=azz2=0.0;
						stop=0;
						ind=6;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(mutant1,seq[i][k-1],seq[i][k]);
						if( aa1!=aa2) {
							x1+=1;
							ax1+=transition(seq[i][k-2],mutant1);
							x2+=1;
							ax2+=transition(seq[i][k-2],mutant1);
							}
						else {
							xx1+=1;
							axx1+=transition(seq[i][k-2],mutant1);
							xx2+=1;
							axx2+=transition(seq[i][k-2],mutant1);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							x1=0;
							ax1=0;
							x2=0;
							ax2=0;
							xx1=0;
							axx1=0;
							xx2=0;
							axx2=0;
							ind-=2;
							}
						else {
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								x1+=1;
								ax1+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx1+=1;
								axx1+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								x1+=1;
								ax1+=transition(seq[i][k],mutant3);
								}
							else {
								xx1+=1;
								axx1+=transition(seq[i][k],mutant3);
								}
							if(stop==10) {
									x1=0;
									ax1=0;
									xx1=0;
									axx1=0;
									ind-=1;
									}
							aa1=translate(mutant1,seq[i][k-1],seq[i][k]);
							aa2=translate(mutant1,seq[i][k-1],mutant3);

							if( aa1!=aa2) {
								x2+=1;
								ax2+=transition(seq[i][k],mutant3);
								}
							else {
								xx2+=1;
								axx2+=transition(seq[i][k],mutant3);
								}
							if( aa2==21) stop+=20;
							aa1=translate(mutant1,seq[i][k-1],mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								x2+=1;
								ax2+=transition(seq[i][k-1],mutant2);
								}
							else {
								xx2+=1;
								axx2+=transition(seq[i][k-1],mutant2);
								}
							if(stop==20 || stop==30) {
										x2=0;
										ax2=0;
										xx2=0;
										axx2=0;
										ind-=1;
										}
							}

						stop=0;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[i][k-2],mutant2,seq[i][k]);
						if( aa1!=aa2) {
							y1+=1;
							ay1+=transition(seq[i][k-1],mutant2);
							y2+=1;
							ay2+=transition(seq[i][k-1],mutant2);
							}
						else {
							yy1+=1;
							ayy1+=transition(seq[i][k-1],mutant2);
							yy2+=1;
							ayy2+=transition(seq[i][k-1],mutant2);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							y1=0;
							ay1=0;
							y2=0;
							ay2=0;
							yy1=0;
							ayy1=0;
							yy2=0;
							ayy2=0;
							ind-=2;
							}
						else {
							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,seq[i][k]);
							if( aa1!=aa2) {
								y1+=1;
								ay1+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy1+=1;
								ayy1+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,mutant2,seq[i][k]);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								y1+=1;
								ay1+=transition(seq[i][k],mutant3);
								}
							else {
								yy1+=1;
								ayy1+=transition(seq[i][k],mutant3);
								}
							if(stop==10) {
									y1=0;
									ay1=0;
									yy1=0;
									ayy1=0;
									ind-=1;
									}

							aa1=translate(seq[i][k-2],mutant2,seq[i][k]);
							aa2=translate(seq[i][k-2],mutant2,mutant3);
							if( aa1!=aa2) {
								y2+=1;
								ay2+=transition(seq[i][k],mutant3);
								}
							else {
								yy2+=1;
								ayy2+=transition(seq[i][k],mutant3);
								}
							if( aa2==21) stop+=20;
							aa1=translate(seq[i][k-2],mutant2,mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								y2+=1;
								ay2+=transition(seq[i][k-2],mutant1);
								}
							else {
								yy2+=1;
								ayy2+=transition(seq[i][k-2],mutant1);
								}
							if(stop==20 || stop==30) {
										y2=0;
										ay2=0;
										yy2=0;
										ayy2=0;
										ind-=1;
										}
							}
						
						stop=0;
						aa1=translate(seq[i][k-2],seq[i][k-1],seq[i][k]);
						aa2=translate(seq[i][k-2],seq[i][k-1],mutant3);
						if( aa1!=aa2) {
							z1+=1;
							az1+=transition(seq[i][k],mutant3);
							z2+=1;
							az2+=transition(seq[i][k],mutant3);
							}
						else {
							zz1+=1;
							azz1+=transition(seq[i][k],mutant3);
							zz2+=1;
							azz2+=transition(seq[i][k],mutant3);
							}
						if( aa2==21) stop+=1;
						if(stop==1) {
							z1=0;
							az1=0;
							z2=0;
							az2=0;
							zz1=0;
							azz1=0;
							zz2=0;
							azz2=0;
							ind-=2;
							}
						else {
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(mutant1,seq[i][k-1],mutant3);
							if( aa1!=aa2) {
								z1+=1;
								az1+=transition(seq[i][k-2],mutant1);
								}
							else {
								zz1+=1;
								azz1+=transition(seq[i][k-2],mutant1);
								}
							if( aa2==21) stop+=10;
							aa1=translate(mutant1,seq[i][k-1],mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								z1+=1;
								az1+=transition(seq[i][k-1],mutant2);
								}
							else {
								zz1+=1;
								azz1+=transition(seq[i][k-1],mutant2);
								}
							if(stop==10) {
									z1=0;
									az1=0;
									zz1=0;
									azz1=0;
									ind-=1;
									}
							aa1=translate(seq[i][k-2],seq[i][k-1],mutant3);
							aa2=translate(seq[i][k-2],mutant2,mutant3);

							if( aa1!=aa2) {
								z2+=1;
								az2+=transition(seq[i][k-1],mutant2);
								}
							else {
								zz2+=1;
								azz2+=transition(seq[i][k-1],mutant2);
								}
							if( aa2==21) stop+=20;
							aa1=translate(seq[i][k-2],mutant2,mutant3);
							aa2=translate(mutant1,mutant2,mutant3);
							if( aa1!=aa2) {
								z2+=1;
								az2+=transition(seq[i][k-2],mutant1);
								}
							else {
								zz2+=1;
								azz2+=transition(seq[i][k-2],mutant1);
								}
							if(stop==20 || stop==30) {
										z2=0;
										az2=0;
										zz2=0;
										azz2=0;
										ind-=1;
										}
							}
						if(ind!=0) {
							nd[w][v]+=( (x1+x2+y1+y2+z1+z2)/ind );
							Nd+=( (x1+x2+y1+y2+z1+z2)/ind );
							ad[w][v]+=( (ax1+ax2+ay1+ay2+az1+az2)/ind );
							Ad+=( (ax1+ax2+ay1+ay2+az1+az2)/ind );
							sd[w][v]+=( (xx1+xx2+yy1+yy2+zz1+zz2)/ind );
							Sd+=( (xx1+xx2+yy1+yy2+zz1+zz2)/ind );
							as[w][v]+=( (axx1+axx2+ayy1+ayy2+azz1+azz2)/ind );
							As+=( (axx1+axx2+ayy1+ayy2+azz1+azz2)/ind );
							}
						}
				}
				N=(N1+N2)/2;
				S=Nsites-N;
				switch(r) {
					case 2:
						if(R==2) {
							if(dist==1) {
								Ps=Sd/S;
								if(Ps>=0.75) {
									sat=1;
									break;
									}
								ka[i][j]=-(3.0/4)*log( 1-((4.0/3)*Ps) );
								}
							if(dist==2) {
								Pn=Nd/N;
								if(Pn>=0.75) {
									sat=1;
									break;
									}
								ka[i][j]=-(3.0/4)*log( 1-((4.0/3)*Pn) );
								}
							break;
							}
						else {
							if(invar==1) {
								N*=(1-t);
								S*=(1-t);
								}
							if(dist==1) {
								Ps=Sd/S;
								if(Ps>=0.75) {
									sat=1;
									break;
									}
								if(distrib==2) ka[i][j]=truncnegbinjcdist(Ps);
								else ka[i][j]=(3.0/4)*a*( pow( (1-(4.0/3)*Ps),(-1.0/a) ) - 1 );
								}
							if(dist==2) {
								Pn=Nd/N;
								if(Pn>=0.75) {
									sat=1;
									break;
									}
								if(distrib==2) ka[i][j]=truncnegbinjcdist(Pn);
								else ka[i][j]=(3.0/4)*a*( pow( (1-(4.0/3)*Pn),(-1.0/a) ) - 1 );
								}
							break;
							}
					default:
						if(R==2) {
							if(dist==1) {
								Cs=As/S;
								Ds=(Sd-As)/S;
								if( Ds>=0.5 || (2*Cs+Ds)>=1 ) {
										sat=1;
										break;
										}
								if(transiversions==1 ) {
									ka[i][j]=-(1.0/2.0)*log( 1-2*Ds );
									/*if(Cs!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*Cs-Ds )+(1.0/4.0)*log( 1-2*Ds ));*/
									}
								else {
									if(Cs==0.0) ka[i][j]=-(1.0/2.0)*log( 1-2*Ds );
									else ka[i][j]=-(1.0/2.0)*log( (1-2*Cs-Ds)*sqrt(1-2*Ds) );
									}
								}
							if(dist==2) {
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								if( Bn>=0.5 || (2*An+Bn)>=1 ) {
										sat=1;
										break;
										}
								if(transiversions==1 ) {
									ka[i][j]=-(1.0/2.0)*log( 1-2*Bn );
									/*if(An!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*An-Bn )+(1.0/4.0)*log( 1-2*Bn ));*/
									}
								else {
									if(An==0.0) ka[i][j]=-(1.0/2.0)*log( 1-2*Bn );
									else ka[i][j]=-(1.0/2.0)*log( (1-2*An-Bn)*sqrt(1-2*Bn) );
									}
								}
							break;
							}
						else {
							if(invar==1) {
								N*=(1-t);
								S*=(1-t);
								}
							if(dist==1) {
								Cs=As/S;
								Ds=(Sd-As)/S;
								if( Ds>=0.5 || (2*Cs+Ds)>=1 ) {
											sat=1;
											break;
											}
								if(distrib==2) ka[i][j]=truncnegbinkimdist(Cs, Ds);
								else ka[i][j]=(a/2.0)*( pow( (1-2*Cs-Ds),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Ds),(-1.0/a) ) - 1.5 );
								}
							if(dist==2) {
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								if( Bn>=0.5 || (2*An+Bn)>=1 ) {
											sat=1;
											break;
											}
								if(distrib==2) ka[i][j]=truncnegbinkimdist(An, Bn);
								else ka[i][j]=(a/2.0)*( pow( (1-2*An-Bn),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Bn),(-1.0/a) ) - 1.5 );
								}
							break;
							}
					}
				if(sat==1) break;
				}
		if(sat==1) break;
		}
return sat;
}


int neigojodist(int Nseq, int Nsites, double **ka, double **n, double **nd, double **ad, double **sd, double **as, int R, int r, int invar, int dist, int distrib, double t)
{
int i, j, k, w, sat;
double Nd, Ad, N, N1, N2, Pn, An, Bn, Sd, As, S, Ps, Cs, Ds;

/*printf("MOY=%f\n", MOY);*/

sat=0;
for(w=0,i=0;i<(Nseq-1);i++) {
		for(j=(i+1);j<Nseq;j++,w++) {
				Nd=Ad=0.0;
				Sd=As=0.0;
				N1=N2=0.0;
				for(k=0;k<Nsites/3;k++) {
					N1+=n[i][k];
					N2+=n[j][k];
					Nd+=nd[w][k];
					Ad+=ad[w][k];
					Sd+=sd[w][k];
					As+=as[w][k];
					}
				N=(N1+N2)/2;
				S=Nsites-N;
				switch(r) {
					case 2:
						if(R==2) {
							if(dist==1) {
								Ps=Sd/S;
								if(Ps>=0.75) {
									sat=1;
									break;
									}
								ka[i][j]=-(3.0/4)*log( 1-((4.0/3)*Ps) );
								}
							if(dist==2) {
								Pn=Nd/N;
								if(Pn>=0.75) {
									sat=1;
									break;
									}
								ka[i][j]=-(3.0/4)*log( 1-((4.0/3)*Pn) );
								}
							break;
							}
						else {
							if(invar==1) {
								N*=(1-t);
								S*=(1-t);
								}
							if(dist==1) {
								Ps=Sd/S;
								if(Ps>=0.75) {
									sat=1;
									break;
									}
								if(distrib==2) ka[i][j]=truncnegbinjcdist(Ps);
								else ka[i][j]=(3.0/4)*a*( pow( (1-(4.0/3)*Ps),(-1.0/a) ) - 1 );
								}
							if(dist==2) {
								Pn=Nd/N;
								if(Pn>=0.75) {
									sat=1;
									break;
									}
								if(distrib==2) ka[i][j]=truncnegbinjcdist(Pn);
								else ka[i][j]=(3.0/4)*a*( pow( (1-(4.0/3)*Pn),(-1.0/a) ) - 1 );
								}
							break;
							}
					default:
						if(R==2) {
							if(dist==1) {
								Cs=As/S;
								Ds=(Sd-As)/S;
								if( Ds>=0.5 || (2*Cs+Ds)>=1 ) {
										sat=1;
										break;
										}
								if(transiversions==1 ) {
									ka[i][j]=-(1.0/2.0)*log( 1-2*Ds );
									/*if(Cs!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*Cs-Ds )+(1.0/4.0)*log( 1-2*Ds ));*/
									}
								else {
									if(Cs==0.0) ka[i][j]=-(1.0/2.0)*log( 1-2*Ds );
									else ka[i][j]=-(1.0/2.0)*log( (1-2*Cs-Ds)*sqrt(1-2*Ds) );
									}
								}
							if(dist==2) {
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								if( Bn>=0.5 || (2*An+Bn)>=1 ) {
										sat=1;
										break;
										}
								if(transiversions==1 ) {
									ka[i][j]=-(1.0/2.0)*log( 1-2*Bn );
									/*if(An!=0.0) printf("%f, ", -(1.0/2.0)*log( 1-2*An-Bn )+(1.0/4.0)*log( 1-2*Bn ));*/
									}
								else {
									if(An==0.0) ka[i][j]=-(1.0/2.0)*log( 1-2*Bn );
									else ka[i][j]=-(1.0/2.0)*log( (1-2*An-Bn)*sqrt(1-2*Bn) );
									}
								}
							break;
							}
						else {
							if(invar==1) {
								N*=(1-t);
								S*=(1-t);
								}
							if(dist==1) {
								Cs=As/S;
								Ds=(Sd-As)/S;
								if( Ds>=0.5 || (2*Cs+Ds)>=1 ) {
											sat=1;
											break;
											}
								if(distrib==2) ka[i][j]=truncnegbinkimdist(Cs, Ds);
								else ka[i][j]=(a/2.0)*( pow( (1-2*Cs-Ds),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Ds),(-1.0/a) ) - 1.5 );
								}
							if(dist==2) {
								An=Ad/N;
								Bn=(Nd-Ad)/N;
								if( Bn>=0.5 || (2*An+Bn)>=1 ) {
											sat=1;
											break;
											}
								if(distrib==2) ka[i][j]=truncnegbinkimdist(An, Bn);
								else ka[i][j]=(a/2.0)*( pow( (1-2*An-Bn),(-1.0/a) ) + (1.0/2.0)*pow( (1-2*Bn),(-1.0/a) ) - 1.5 );
								}
							break;
							}
					}
				if(sat==1) break;
				}
		if(sat==1) break;
		}

return sat;
}


/*function which translates the codons into amino acids using the genetic code*/
int translate(char c1, char c2, char c3)
{
int aa;
enum aminoacid { ala=1, arg, asn, asp, cys, gln, glu, gly, his, ileu, leu, lys, met, phe, pro, ser, thr, trp, tyr, val, stop};   /*ici, pas besoin de distinguer entre ser1 et ser2 puisqu'on ne peut pas*/
			/*passer directement d'une serine a l'autre par un seul changement*/

     	     if( c1=='A' && c2=='A' && (c3=='A'||c3=='G') ) aa=lys ;
	else if( c1=='A' && c2=='A' && (c3=='C'||c3=='T') ) aa=asn ;
	else if( c1=='A' && c2=='C' )                       aa=thr ;
	else if( c1=='A' && c2=='G' && (c3=='A'||c3=='G') ) aa=arg ;
	else if( c1=='A' && c2=='G' && (c3=='C'||c3=='T') ) aa=ser ;
	else if( c1=='A' && c2=='T' && c3!='G' )            aa=ileu;
	else if( c1=='A' && c2=='T' && c3=='G' )            aa=met ;
	else if( c1=='C' && c2=='A' && (c3=='A'||c3=='G') ) aa=gln ;
	else if( c1=='C' && c2=='A' && (c3=='C'||c3=='T') ) aa=his ;
	else if( c1=='C' && c2=='C' )                       aa=pro ;
	else if( c1=='C' && c2=='G' )                       aa=arg ;
	else if( c1=='C' && c2=='T' )                       aa=leu ;
	else if( c1=='G' && c2=='A' && (c3=='A'||c3=='G') ) aa=glu ;
	else if( c1=='G' && c2=='A' && (c3=='C'||c3=='T') ) aa=asp ;
	else if( c1=='G' && c2=='C' )                       aa=ala ;
	else if( c1=='G' && c2=='G' )                       aa=gly ;
	else if( c1=='G' && c2=='T' )                       aa=val ;
	else if( c1=='T' && c2=='A' && (c3=='A'||c3=='G') ) aa=stop;
	else if( c1=='T' && c2=='A' && (c3=='C'||c3=='T') ) aa=tyr ;
	else if( c1=='T' && c2=='C' )                       aa=ser ;
	else if( c1=='T' && c2=='G' && c3=='A' )            aa=stop;
	else if( c1=='T' && c2=='G' && (c3=='C'||c3=='T') ) aa=cys ;
	else if( c1=='T' && c2=='G' && c3=='G' )            aa=trp ;
	else if( c1=='T' && c2=='T' && (c3=='A'||c3=='G') ) aa=leu ;
	                        else aa=phe ;

return aa;
}

 
/*function which calculates the number of nonsynonymous sites for one codon only (in fact, this corresponds to the table of Perler)*/
double numsites(char c1, char c2, char c3)
{
int aa;
double N;

aa=translate(c1, c2, c3);

     if(aa==1 || aa==8 || aa==15 || aa==17 || aa==20) N=6;
else if(aa==3 || aa==4 || aa==5 || aa==6 || aa==7 || aa==9 || aa==12 || aa==14 || aa==19) N=8;
else if(aa==13 || aa==18) N=9;
else if(aa==10) N=7;
else if(aa==2) {
	if( c1=='C' && c2=='G' && (c3=='C' || c3=='T') ) N=6;
	else if( c1=='C' && c2=='G' && (c3=='A' || c3=='G') ) N=5;
	else N=7;
	}
else if(aa==11) {
	if( c1=='C' && c2=='T' && (c3=='C' || c3=='T') ) N=6;
	else if( c1=='C' && c2=='T' && (c3=='A' || c3=='G') ) N=5;
	else N=7;
	}
else if(aa==16) {
	if( c1=='A' && c2=='G' ) N=8;
	else N=6;
	}
else printf("stop");

return N/3;
}


/*function which calculates the number of transitional changes*/
double transition(char c1, char c2)
{
double x;

if( (c1=='A' && c2=='G') || (c1=='G' && c2=='A') || (c1=='C' && c2=='T') || (c1=='T' && c2=='C') ) x=1.0;
else x=0.0;

return x; 
}
