/*Studier-Keppler*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 1000
#define NSM 300

int nsm; static double *d[NSM]; static char *nm[NSM];
int n, ns, nf;
static int *id, *t; static double *la;
static int *droit, *gauche;
int root=0;
int FINAL;

void sk(double **ka, char **seqname, int **clusters, int Nseq, FILE *outfile, double *bootvalues);
void Rij(double **d, int n);
void Sij(int *ii, int *jj);
void reduction(int ii, int jj);
void sommets();
void LirTab(double **ka, char **seqname, int *n);
void SymTab(double **d, int n);
void cherchedesc(int *t, int ns, int node, int *gauche, int *droit, int **clusters);
void printparent(int node, int *gauche, int *droit, int nf, char **nm, double *la, FILE *outfile, double *bootvalues);


void Rij(double **d, int n)
{
/*place the sum of the distances between i and all others in d[i][i].
*d[] must be symmetrized before*/

  int i,j; double smd;

  smd=0;
  for(j=1;j<=n;j++){ 
    		smd=0;
    		for(i=1;i<=n;i++) if(i!=j) smd+=d[i][j];
    		d[j][j]=smd;
  		}     
}

void Sij(int *ii, int *jj)
{
  int i,j; double sij,smin;
 
  smin=0;

  for(i=1;i<=n;i++)
    for(j=i+1;j<=n;j++){
  
      	sij=d[i][j]*(n-2)-d[i][i]-d[j][j];

	if(sij<=smin) {*ii=i; *jj=j; smin=sij;}   /*search for the smallest sij*/
    	}
/*printf("smin=%f\n", smin);*/
  
  ns+=1; t[id[*ii]]=ns; t[id[*jj]]=ns;

 
  la[id[*ii]]=((n-2)*d[*ii][*jj]+d[*ii][*ii]-d[*jj][*jj])/(2*(n-2));
  la[id[*jj]]=((n-2)*d[*ii][*jj]-d[*ii][*ii]+d[*jj][*jj])/(2*(n-2));
/*printf("%f %f, ", la[id[*ii]],la[id[*jj]]);*/
}

void reduction(int ii,int jj)
{
  int i;

  for(i=1;i<=n;i++) if(i!=ii && i!=jj){
     			d[i][ii]=(d[i][ii]+d[i][jj]-d[ii][jj])/2; d[ii][i]=d[i][ii];
   			 }
  
  d[ii][ii]=0; id[ii]=ns; 

  for(i=1;i<n;i++){				/* n->jj */
    	d[i][jj]=d[i][n]; d[jj][i]=d[n][i];
  	}

  d[jj][jj]=0; id[jj]=id[n];
       
  n-=1;  
}

void sommets(void)
{
  int i,j,k;

  i=id[1]; j=id[2]; k=id[3];
  ns+=1; t[i]=t[j]=t[k]=ns;

  
  la[i]=(d[1][2]+d[1][3]-d[2][3])/2;
  la[j]=(d[1][2]+d[2][3]-d[1][3])/2;
  la[k]=(d[1][3]+d[2][3]-d[1][2])/2;
/*printf("som=%f %f %f, ", la[i], la[j], la[k]);*/
}

void LirTab(double **ka, char **seqname, int *n)
{

   /*d[i][j] i->columns j->lines*/


  int kk; int i,j;

  for(i=1; i<=nsm-1; i++) {
		/*read the distances*/
		for(j=i+1; j<=nsm; j++) {
				d[i][j]=ka[i][j];
				/*printf("k[%d][%d]=%f,", i, j, ka[i][j]);
				printf("d[%d][%d]=%f,", i, j, d[i][j]);*/
				}		
		}

  for(i=1; i<=nsm; i++) {
		/*read the species names*/
		strcpy(nm[i],seqname[i-1]);
		}

/*for(i=1;i<=nsm;i++) printf("%d %s\n", i, nm[i]);*/

  *n=nsm;
/*printf("n=%d\n", n);*/

}


void SymTab(double **d, int n)
{
/*copy lower triangle into upper triangle (i.e., symmetrize the distance matrix)*/

  int i,j;

  for(j=1;j<=n;j++) for(i=1;i<j;i++) d[j][i]=d[i][j]; 
}


void sk(double **ka, char **seqname, int **clusters, int Nseq, FILE *outfile, double *bootvalues)
{
  int it,i,ii,jj,imp=0;
  int compt, node1, node2, node3;
  int L, temp;
  double sumla;
  static int appel=0;


  /*printf("\nprintout (type <1> to write the description of the clustering cycles in the tree file, else type <0>): ");
  scanf("%d", &imp);*/


  nsm=Nseq;              /*read the number of sequences*/
  /*printf("nsm=%d\n", nsm);*/


if(appel==0) {
	/*memory allocations for arrays*/
	for(i=1; i<=nsm; i++) if( (nm[i]=(char *)malloc( 21*sizeof(char) ))==NULL ) {
						printf("not enough memory for array nm\n");
						exit(-2);
						}
	/*for array *id, subscript numbering goes from 1 to nsm, not from 0 to nsm-1. Thus, nsm+1 elements are allocated in order to compute id[nsm]*/
	if( (id=(int *)malloc( (nsm+1)*sizeof(int) ))==NULL ) {
					printf("not enough memory for array id\n");
					exit(-2);
					}
	if( (t=(int *)malloc( (2*nsm)*sizeof(int) ))==NULL ) {
					printf("not enough memory for array t\n");
					exit(-2);
					}
	if( (la=(double *)malloc( (2*nsm)*sizeof(double) ))==NULL ) {
					printf("not enough memory for array la\n");
					exit(-2);
					}

	/*WARNING: arrays *gauche and *droit are made up of nsm elements, but subscript numbering goes from nf to ns. This explains why we use gauche[i-nf] and droit[i-nf] below*/
	if( (droit=(int *)malloc( nsm*sizeof(int) ))==NULL ) {
					printf("not enough memory for array droit\n");
					exit(-2);
					}
	if( (gauche=(int *)malloc( nsm*sizeof(int) ))==NULL ) {
					printf("not enough memory for array gauche\n");
					exit(-2);
					}
	for(i=1;i<=nsm;i++) {
		/*for each array d[i], the same strategy as for the array *id above is used*/
		if( (d[i]=(double *)malloc( (nsm+1)*sizeof(double) ))==NULL ) {
					printf("not enough memory for array d\n");
					exit(-2);
					}
		}
	appel=1;
	}
		
LirTab(ka,seqname,&n);
/*printf("\n");
for(i=1;i<=nsm;i++) printf("%s,", nm[i]);*/

  ns=nf=n; for(i=1;i<=n;i++) id[i]=i;

  it=0;
  while (n>3){
    		it+=1;
    		SymTab(d,n); 
		Rij(d,n);
    		Sij(&ii,&jj);
    		reduction(ii,jj);  
  		}
  sommets();

 
  for(i=1;i<=ns;i++) if(la[i]<=0.0) la[i]=0.0;     /*NO NEGATIVE BRANCH LENGTHS!!*/

  

for(i=nf+1; i<ns; i++) cherchedesc(t, ns, i, gauche, droit, clusters);

for(compt=0,i=1; i<ns; i++) if(t[i]==ns) {
				if(compt==0) {
					node1=i;
					compt=1;
					}
				else if(compt==1) {
					node2=i;
					compt=2;
					}
				else if(compt==2) {
					node3=i;
					compt=3;
					}
				else break;
				}

if(FINAL==1) {
	/*for(i=nf+1; i<ns; i++) printf("bvsk(%d)=%f\n", i-nf, bootvalues[i-nf]);*/
	fprintf(outfile, "(");
	/*fprintf(outfile, "(");*/
	if(node1<=nf) {
		fprintf(outfile, "%s:", nm[node1]);
		fprintf(outfile, "%.6f", la[node1]);
		}
	else printparent(node1, gauche, droit, nf, nm, la, outfile, bootvalues);
	fprintf(outfile, ",");
	if(node2<=nf) {
		fprintf(outfile, "%s:", nm[node2]);
		fprintf(outfile, "%.6f", la[node2]);
		}
	else printparent(node2, gauche, droit, nf, nm, la, outfile, bootvalues);
	/*fprintf(outfile, ")");*/
	/*fprintf(outfile, ":%.6f", 0.5*la[node3]);*/
	root=0;
	fprintf(outfile, ",");
	if(node3<=nf) {
		fprintf(outfile, "%s:", nm[node3]);
		/*fprintf(outfile, "%.6f", 0.5*la[node3]);*/
		fprintf(outfile, "%.6f", la[node3]);
		}
	else printparent(node3, gauche, droit, nf, nm, la, outfile, bootvalues);
	fprintf(outfile, ");");
	}


if(imp==1 && FINAL==1) {
	for(i=nf+1; i<ns; i++) {
			fprintf(outfile, "\n\nCycle %4d   ", i-nf);
			if(gauche[i-nf]<=nf) fprintf(outfile, " OTU %4d (%6.4f)", gauche[i-nf], la[gauche[i-nf]]);
			else fprintf(outfile, "node %4d (%6.4f)", gauche[i-nf], la[gauche[i-nf]]);
			fprintf(outfile, "  and  ");
			if(droit[i-nf]<=nf) fprintf(outfile, " OTU %4d (%6.4f)", droit[i-nf], la[droit[i-nf]]);
			else fprintf(outfile, "node %4d (%6.4f)", droit[i-nf], la[droit[i-nf]]);
			fprintf(outfile, "  grouped in %4d\n", i);
			if(gauche[i-nf]<=nf) fprintf(outfile, "             %-25s", nm[gauche[i-nf]]);
			if(droit[i-nf]<=nf) fprintf(outfile, "%s", nm[droit[i-nf]]);
			}
	fprintf(outfile, "\n\nLast cycle:\n\n");
	if(node1<=nf) fprintf(outfile, " OTU %4d (%6.4f)", node1, la[node1]);
	else fprintf(outfile, "node %4d (%6.4f)", node1, la[node1]);
	fprintf(outfile, " , ");
	if(node2<=nf) fprintf(outfile, " OTU %4d (%6.4f)", node2, la[node2]);
	else fprintf(outfile, "node %4d (%6.4f)", node2, la[node2]);
	fprintf(outfile, "  and  ");
	if(node3<=nf) fprintf(outfile, " OTU %4d (%6.4f)", node3, la[node3]);
	else fprintf(outfile, "node %4d (%6.4f)", node3, la[node3]);
	fprintf(outfile, "  grouped in %4d\n", ns);
	if(node1<=nf) fprintf(outfile, "%-22s", nm[node1]);
	if(node2<=nf) fprintf(outfile, "%-25s", nm[node2]);
	if(node3<=nf) fprintf(outfile, "%s", nm[node3]);
	}


sumla=0.0;
for(i=1;i<=ns;i++) {
		/*if(i<=nf) printf("id=%d, ", id[i]);*/
		if(i<ns) {
			/*printf("la=%f, ", la[i]);*/
			sumla+=la[i];
			}
		/*if(i>nf && i<ns) printf("t=%d, ", t[i]);
		if(i>nf && i<ns) printf("droit(%d)=%d, ", i, droit[i-nf]);
		if(i>nf && i<ns) printf("gauche(%d)=%d, ", i, gauche[i-nf]);
		if(i<ns) printf("t=%d, ", t[i]);*/
		}
/*printf("total length of the tree (%d branches)=%f\n", 2*nsm-3, sumla);*/

for(i=1; i<=nsm-3; i++) {
			if( fabs(clusters[2][i])<fabs(clusters[1][i]) ) {
				temp=clusters[1][i];
				clusters[1][i]=clusters[2][i];
				clusters[2][i]=temp;
				}
			/*else {
				clusters[1][i]=clusters[2][i];
				clusters[2][i]=clusters[1][i];
				}*/
			/*printf("cl[1][%d]=%d, cl[2][%d]=%d\n", i, clusters[1][i], i, clusters[2][i]);*/
			}


/*printf("tree file created: %s\n", outfil);
fclose(infile);
fclose(outfile);*/

}


/*function which searches for the 2 descendants of each internal node*/
void cherchedesc(int *t, int ns, int node, int *gauche, int *droit, int **clusters)
{
int i;
int compt=0;

for(i=1; i<ns; i++) if(t[i]==node) {
				if(compt==0) {
					gauche[node-nf]=i;
					clusters[1][node-nf]=i;
					if(i>nf) {
						if(fabs(clusters[1][i-nf])<fabs(clusters[2][i-nf])) clusters[1][node-nf]=fabs(clusters[1][i-nf]);
						else clusters[1][node-nf]=fabs(clusters[2][i-nf]);
						clusters[1][node-nf]*=(-1);
						}
					/*printf("g(%d)=%d\n", node, clusters[1][node-nf]);*/
					compt=1;
					}
				else if(compt==1) {
					droit[node-nf]=i;
					clusters[2][node-nf]=i;
					if(i>nf) {
						if(fabs(clusters[1][i-nf])<fabs(clusters[2][i-nf])) clusters[2][node-nf]=fabs(clusters[1][i-nf]);
						else clusters[2][node-nf]=fabs(clusters[2][i-nf]);
						clusters[2][node-nf]*=(-1);
						}
					/*printf("d(%d)=%d\n", node, clusters[2][node-nf]);*/
					compt=2;
					}
				else break;
				}
}

/*function which writes the tree in the parenthesized notation*/
void printparent(int node, int *gauche, int *droit, int nf, char **nm, double *la, FILE *outfile, double *bootvalues)
{
static int ouv=0, fer=0;

if(node>nf) {
	fprintf(outfile, "(");
	ouv++;
	if(gauche[node-nf]<=nf) {
		fprintf(outfile, "%s:", nm[gauche[node-nf]]);
		fprintf(outfile, "%.6f", la[gauche[node-nf]]);
		}
	else printparent(gauche[node-nf], gauche, droit, nf, nm, la, outfile, bootvalues);
	fprintf(outfile, ",");
	if(droit[node-nf]<=nf) {
			fprintf(outfile, "%s:", nm[droit[node-nf]]);
			fprintf(outfile, "%.6f", la[droit[node-nf]]);
			}
	printparent(droit[node-nf], gauche, droit, nf, nm, la, outfile, bootvalues);
	fprintf(outfile, ")");
	fer++;
	if(root==1 && ouv==fer) {
			/*printf("bvsk(%d)=%f\n", node-nf, bootvalues[node-nf]);*/
			fprintf(outfile, "%.0f:%.6f", bootvalues[node-nf], 0.5*la[node]);
			}
	else {
		/*printf("bvsk(%d)=%f\n", node-nf, bootvalues[node-nf]);*/
		fprintf(outfile, "%.0f:%.6f", bootvalues[node-nf], la[node]);
		}
	}

}

